;#AutoIt3Wrapper_UseX64=y

#include ".\Includes\CLR.au3"

Example()

Func Example()
  Local $oAppDomain = _CLR_GetDefaultDomain()

  ; Create a 1D array with one integer element
  Local $aArgs = [ 128 ], $psa = CreateSafeArray( $aArgs )

  ; Create an instance of ArrayList using a parameterized constructor
  Local $pHandle
  $oAppDomain.CreateInstance_3( "mscorlib", "System.Collections.ArrayList", True, 0, 0, $psa, 0, 0, 0, $pHandle )
  ConsoleWrite( @CRLF & "$pHandle = " & $pHandle & @CRLF )

  Local $oHandle = ObjCreateInterface( $pHandle, $sIID_IObjectHandle, $sTag_IObjectHandle )
  ConsoleWrite( @CRLF & "IsObj( $oHandle ) = " & IsObj( $oHandle ) & @CRLF )

  ; Unwrap the ArrayList instance inside the ObjectHandle
  Local $oArrayList
  $oHandle.Unwrap( $oArrayList )
  ConsoleWrite( @CRLF & "IsObj( $oArrayList ) = " & IsObj( $oArrayList ) & @CRLF )

  ; Print ArrayList Capacity
  ConsoleWrite( @CRLF & "$oArrayList.Capacity() = " & $oArrayList.Capacity() & @CRLF )
EndFunc

ConsoleWrite(@CRLF)

Example_Text()

Func Example_Text()
  Local $oAppDomain = _CLR_GetDefaultDomain()

  ; Create an instance using a parameterized constructor
  Local $pHandle
  $oAppDomain.CreateInstance( "mscorlib", "System.Text.StringBuilder",  $pHandle )
  ConsoleWrite( @CRLF & "$pHandle = " & $pHandle & @CRLF )

  Local $oHandle = ObjCreateInterface( $pHandle, $sIID_IObjectHandle, $sTag_IObjectHandle )
  ConsoleWrite( @CRLF & "IsObj( $oHandle ) = " & IsObj( $oHandle ) & @CRLF )

  ; Unwrap the ArrayList instance inside the ObjectHandle
  Local $oArrayList
  $oHandle.Unwrap( $oArrayList )
  ConsoleWrite( @CRLF & "IsObj( $oArrayList ) = " & IsObj( $oArrayList ) & @CRLF )

	$vStr1 = "Hello"
    $vStr2 = " World"
	$vStr3 = "  - Larsj did it again !!!! :-) "

	$oArrayList.Append_3($vStr1)
	$oArrayList.Append_3($vStr2)
	$oArrayList.Append_3($vStr3)

  ; Print ArrayList Appended Text
;~   ConsoleWrite( @CRLF & "$oArrayList.StringBuilder() = " & $oArrayList.ToString() & @CRLF & @CRLF )
  MsgBox(0,"Text.StringBuilder",$oArrayList.ToString())

EndFunc

ConsoleWrite(@CRLF)

; Better approach is this way using _CLR_CreateObject

Example_ArrayList()

Func Example_ArrayList()
  Local $oAssembly = _CLR_LoadLibrary( "mscorlib" )
  Local $oArrayList = _CLR_CreateObject( $oAssembly, "System.Collections.ArrayList", 128 )
;~    ConsoleWrite( "$oArrayList.Capacity2() = " & $oArrayList.Capacity() & @CRLF )
   Local $sRet = $oArrayList.Capacity()
   MsgBox(0,"$oArrayList.Capacity()", $sRet )
EndFunc

ConsoleWrite(@CRLF)

Example_FileInfo()

Func Example_FileInfo()
  Local $oAssembly = _CLR_LoadLibrary( "mscorlib" )
  Local $oFileInfo = _CLR_CreateObject( $oAssembly, "System.IO.FileInfo", @ScriptDir & "\tst02.txt" )
  ConsoleWrite( "IsObj( $oFileInfo ) = " & IsObj( $oFileInfo ) & @CRLF & @CRLF)
  $oFileInfo.Create()
;~   ConsoleWrite( $oFileInfo.Name & @CRLF)
  MsgBox(0,"System.IO.FileInfo","File Created :  " & $oFileInfo.Name )
EndFunc

ConsoleWrite(@CRLF)

Example_DirectoryInfo()

Func Example_DirectoryInfo()
  Local $Dir = @UserProfileDir
  Local $oAssembly = _CLR_LoadLibrary( "mscorlib" )
  Local $oDirectoryInfo = _CLR_CreateObject( $oAssembly, "System.IO.DirectoryInfo", $Dir & "\Downloads" )
  ConsoleWrite( "IsObj( $oDirectoryInfo ) = " & IsObj( $oDirectoryInfo ) & @CRLF & @CRLF)

;~   ConsoleWrite( "$oDirectoryInfo.Parent() = " & $oDirectoryInfo.Parent().ToString() & @CRLF )
  MsgBox(0,"DirectoryInfo.Parent",$oDirectoryInfo.Parent().ToString())

;~   ConsoleWrite( "$oDirectoryInfo.Root() = " & $oDirectoryInfo.Root().ToString() & @CRLF )
  MsgBox(0,"DirectoryInfo.Root",$oDirectoryInfo.Root().ToString())
EndFunc

ConsoleWrite(@CRLF)