#include ".\Includes\CLR.au3"
#include ".\Includes\CLR Constants.au3"
#include <Date.au3>

Example1() ; System.Random

Func Example1()

	Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)

    local $oRnd =_CLR_CreateObject($oAssembly,"System.Random")
    ConsoleWrite("!$oRnd " & IsObj($oRnd) & @CRLF)

    MsgBox(0,".Net CLR Random #", "System.Random # : " & $oRnd.Next_2( 1, 100 ) & @CRLF)

EndFunc


Example2() ; System.DateTime

Func Example2()
    Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

    ; Create DateTime Object
    Local $pAssemblyType = 0
    $oAssembly.GetType_2("System.DateTime", $pAssemblyType)
    ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

    Local $oActivatorType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
    ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oActivatorType) & @TAB & @CRLF)

    Local $pObject = 0
    $oActivatorType.InvokeMember_3("Now", $GetProperty, 0, 0, 0, $pObject) ; <<<<<<<<<<<<<<<< See bindng Flag 4096 <<<<<<<<<<<<<<<<<<
    ConsoleWrite("IsObject: " & IsObj($pObject) & @TAB & "Now: " & $pObject & @TAB & "Name: " & ObjName($pObject) & @CRLF)

	MsgBox(0,"System.DateTime", "It is Now : " & DateStringToDateTime_EU($pObject))
EndFunc


Example3() ; System.Diagnostics.PerformanceCounter

Func Example3()

  Local $oAssembly = _CLR_LoadLibrary("System")

  ; Get an instance of the System Up Time performance counter.
  Local $Uptime = _CLR_CreateObject( $oAssembly, "System.Diagnostics.PerformanceCounter", "System", "System Up Time", "")
  ConsoleWrite( "IsObj = " & IsObj( $Uptime ) & @CRLF & @CRLF)

  ; Two read counter.
    $Uptime.NextValue();
    Local $nSecs =$Uptime.NextValue()
    $Uptime.Close()

    MsgBox(0,"System Up Time", Round($nSecs / 3600) & " Hours or " & Round($nSecs /60)& " Minutes or " & Round($nSecs) & " Seconds")
EndFunc


Example4() ; System.IO.FileInfo

Func Example4()

    Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

    local $objFileInfoClass =_CLR_CreateObject($oAssembly,"System.IO.FileInfo", @ScriptFullPath )
    ConsoleWrite("!$oRnd " & IsObj($objFileInfoClass) & @CRLF)

    MsgBox(0,".Net CLR System.IO.File #", "FileAttributes # : " & @ScriptFullPath & @CRLF)

    $Attributes = $objFileInfoClass.Attributes ;  Gets or sets the attributes for the current file or directory. (Inherited from FileSystemInfo.)
        ConsoleWrite("$Attributes: " & $Attributes & @CRLF)

    $CreationTime = $objFileInfoClass.CreationTime ;  Gets or sets the creation time of the current file or directory. (Inherited from FileSystemInfo.)
        ConsoleWrite("$CreationTime: " & DateStringToDateTime_EU($CreationTime) & @CRLF)


    $objDirectory = $objFileInfoClass.Directory ;  Gets an instance of the parent directory.
        ConsoleWrite("$objDirectory: " & $objDirectory & @CRLF)

    $DirectoryName = $objFileInfoClass.DirectoryName ;  Gets a string representing the directory's full path.
        ConsoleWrite("$DirectoryName: " & $DirectoryName & @CRLF)

    $Exists = $objFileInfoClass.Exists ;  Gets a value indicating whether a file exists. (Overrides FileSystemInfo.Exists.)
        ConsoleWrite("$Exists: " & $Exists & @CRLF)

    $Extension = $objFileInfoClass.Extension ;  Gets the string representing the extension part of the file. (Inherited from FileSystemInfo.)
        ConsoleWrite("$Extension: " & $Extension & @CRLF)

    $FullName = $objFileInfoClass.FullName ;  Gets the full path of the directory or file. (Inherited from FileSystemInfo.)
        ConsoleWrite("$FullName: " & $FullName & @CRLF)

    $IsReadOnly = $objFileInfoClass.IsReadOnly ;  Gets or sets a value that determines if the current file is read only.
        ConsoleWrite("$IsReadOnly: " &  $IsReadOnly& @CRLF)

    $LastAccessTime = $objFileInfoClass.LastAccessTime ;  Gets or sets the time the current file or directory was last accessed. (Inherited from FileSystemInfo.)
        ConsoleWrite("$LastAccessTime: " & DateStringToDateTime_EU($LastAccessTime) & @CRLF)


    $LastWriteTime = $objFileInfoClass.LastWriteTime ;  Gets or sets the time when the current file or directory was last written to. (Inherited from FileSystemInfo.)
        ConsoleWrite("$LastWriteTime: " & DateStringToDateTime_EU($LastWriteTime) & @CRLF)


    $Length = $objFileInfoClass.Length ;  Gets the size, in bytes, of the current file
        ConsoleWrite("$Length: " & $Length & @CRLF)

    $Name = $objFileInfoClass.Name ;  Gets the name of the file. (Overrides FileSystemInfo.Name.)
        ConsoleWrite("$Name: " & $Name & @CRLF)
EndFunc   ;==>_Example1

Func DateStringToDateTime_EU($dtmDate)
    Return(StringRegExpReplace($dtmDate, "\A(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(?:.*)","$1/$2/$3 $4:$5:$6"))
EndFunc

Func DateStringToDateTime_US($dtmDate)
    Return(StringRegExpReplace($dtmDate, "\A(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(?:.*)","$2/$3/$1 $4:$5:$6"))
EndFunc


Example5() ; System.Int32

Func Example5()

	; Convert DateTime to a CLR DateTime Object
    $aDate = _Date_Time_DOSDateTimeToArray(0x3621, 0x944a) ; 01/01/2007 18:34:20
    ConsoleWrite("FAT date .: " & StringFormat("%02d/%02d/%04d", $aDate[0], $aDate[1], $aDate[2]) & @CRLF)
    ConsoleWrite("FAT time .: " & StringFormat("%02d:%02d:%02d", $aDate[3], $aDate[4], $aDate[5]) & @CRLF & @CRLF)

	; Call CLR Libr.
    Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

    ; Create Object System.Int32 (or Double)
	Local $pAssemblyType = 0
    $oAssembly.GetType_2("System.Int32", $pAssemblyType)
    ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

    Local $oAssemblyType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
    ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oAssemblyType) & @CRLF)

	; Parse Month Text as Int32
	Local $iMonth = 0
	Local $objMonth[] = [ String($aDate[0]) ]

    $oAssemblyType.InvokeMember_3("Parse", 0x158, 0, 0, CreateSafeArray($objMonth), $iMonth)
    ConsoleWrite("$iMonth : " & $iMonth & @CRLF)

	; Parse Day Text as Int32
	Local $iDay = 0
	Local $objDay[] = [ String($aDate[1]) ]

    $oAssemblyType.InvokeMember_3("Parse", 0x158, 0, 0, CreateSafeArray($objDay), $iDay)
    ConsoleWrite("$iDay : " & $iDay & @CRLF)

	; Parse Year Text as Int32
	Local $iYear = 0
	Local $objYear[] = [ String($aDate[2]) ]

    $oAssemblyType.InvokeMember_3("Parse", 0x158, 0, 0, CreateSafeArray($objYear), $iYear)
    ConsoleWrite("$iYear : " & $iYear & @CRLF)

	; Parse Hour Text as Int32
	Local $iHour = 0
	Local $objHour[] = [ String($aDate[3]) ]

    $oAssemblyType.InvokeMember_3("Parse", 0x158, 0, 0, CreateSafeArray($objHour), $iHour)
    ConsoleWrite("$iHour : " & $iHour & @CRLF)

	; Parse Min Text as Int32
	Local $iMin = 0
	Local $objMin[] = [ String($aDate[4]) ]

    $oAssemblyType.InvokeMember_3("Parse", 0x158, 0, 0, CreateSafeArray($objMin), $iMin)
    ConsoleWrite("$iMin : " & $iMin & @CRLF)

	; Parse Sec Text as Int32
	Local $iSec = 0
	Local $objSec[] = [ String($aDate[5]) ]

    $oAssemblyType.InvokeMember_3("Parse", 0x158, 0, 0, CreateSafeArray($objSec), $iSec)
    ConsoleWrite("$iSec : " & $iSec & @CRLF)
	ConsoleWrite(@CRLF)

EndFunc


Example6() ; System.Double

Func Example6()
    Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

    ; Create Double Object
    Local $pAssemblyType = 0
    $oAssembly.GetType_2("System.Double", $pAssemblyType)
    ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

    Local $oActivatorType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
    ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oActivatorType) & @TAB & @CRLF)

    Local $aText[] = ["12,125"]
    Local $iDouble = 0
    $oActivatorType.InvokeMember_3("Parse", 0x158, 0, 0, CreateSafeArray($aText), $iDouble)

    ConsoleWrite("Double : " & $iDouble & @CRLF)
	ConsoleWrite(@CRLF)
EndFunc

Example7() ; System.Speech

Func Example7()
	Local $oAssembly = _CLR_LoadLibrary("System.Speech")
    ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)

	local $oSpeech =_CLR_CreateObject($oAssembly,"System.Speech.Synthesis.SpeechSynthesizer")
    ConsoleWrite("!$oOptions " & IsObj($oSpeech) & @CRLF)

	$cVoice = ""
	$cName=$oSpeech.Voice.Name
	$cVoice=$cVoice & "Name: " & $cName & @CRLF
	$cVoice=$cVoice & "Culture: "& $oSpeech.Voice.Culture & @CRLF
	$cVoice=$cVoice & "Age: " & $oSpeech.Voice.Age & @CRLF
	$cVoice=$cVoice & "Gender: " & $oSpeech.Voice.Gender &@CRLF
	$cVoice=$cVoice & "Description: " & $oSpeech.Voice.Description & @CRLF
	$cVoice=$cVoice & "ID: " & $oSpeech.Voice.Id & @CRLF

	ConsoleWrite( $cVoice& @CRLF)

	; This will obtain an object, you can iterate with a For Next
	; If oSpeech.Voice.SupportedAudioFormats.Count != 0 Then cVoice=cVoice:"Audio Formats: ":oSpeech.Voice.SupportedAudioFormats:@CRLF

	$oSpeech.SelectVoice($cName)
	$oSpeech.Speak("This is a Test - AutoIT Rocks !")
	$oSpeech.Dispose()
	$oSpeech=0
		MsgBox(0,"System.Speech","We just spoke ! ")
	EndFunc

Example8() ; System.Web

Func Example8()
	Local $oAssembly = _CLR_LoadLibrary("System.Web")
    ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

    ; Create DateTime Object
    Local $pAssemblyType = 0
    $oAssembly.GetType_2("System.Web.Security.Membership", $pAssemblyType)
    ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

    Local $oActivatorType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
    ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oActivatorType) & @TAB & @CRLF)

	Local $aText[] = [8,3] ; Length = 8 , NumNonAlpha = 3
	Local $oMembership = 0
    $oActivatorType.InvokeMember_3("GeneratePassword", 0x158, 0, 0, CreateSafeArray($aText), $oMembership)
	ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oMembership) & @TAB & @CRLF)

	ConsoleWrite("Pswd: " & $oMembership  &@CRLF)
	MsgBox(0,"System.Web.Security.Membership","Generated Pswd : " & $oMembership)
EndFunc