;#AutoIt3Wrapper_UseX64=y

#include ".\Includes\CLR.au3"

_Examples()

Func _Examples()
    Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)

    ;1. System.Random Example
    ; https://msdn.microsoft.com/en-us/library/system.random(v=vs.110).aspx
    local $oRnd =_CLR_CreateObject($oAssembly,"System.Random")
    ConsoleWrite("!$oRnd " & IsObj($oRnd) & @CRLF)

    MsgBox(0,".Net CLR Random #", "System.Random # : " & $oRnd.next() & @CRLF)

    ;2. System.String Example
    ; https://msdn.microsoft.com/en-us/library/system.string(v=vs.110).aspx
    local $oText =_CLR_CreateObject($oAssembly,"System.Text.UTF8Encoding")
    ConsoleWrite("!$oText UTF8Encoding" & IsObj($oText) & @CRLF & @CRLF)

    local $sPswd = "P@ssW0rd"
    MsgBox(0,".Net CLR",$sPswd & " Text Using : " & @CRLF & "System.Text.UTF8Encoding :" & @CRLF & @CRLF & $oText.GetBytes_4($sPswd))

    local $oSHA512 =_CLR_CreateObject($oAssembly,"System.Security.Cryptography.SHA512Managed")
    ConsoleWrite($oSHA512.ComputeHash_2($oText.GetBytes_4("P@ssW0rd"))   & @CRLF)
    MsgBox(0,".Net CLR SHA512Managed",$sPswd & " UTF8Encoding To : " & @CRLF & "System.Security.Cryptography.SHA512Managed :" & @CRLF & @CRLF & $oSHA512.ComputeHash_2($oText.GetBytes_4("P@ssW0rd")))

    ;3. SafeArray RankMismatch Example
    ; https://msdn.microsoft.com/en-us/library/system.runtime.interopservices.safearrayrankmismatchexception(v=vs.110).aspx
    local $oSafeArrayError =_CLR_CreateObject($oAssembly,"System.Runtime.InteropServices.SafeArrayRankMismatchException")
    ConsoleWrite(@CRLF & "$oSafeArrayError Obj. : " & IsObj($oSafeArrayError) & @CRLF & _
                "SafeArrayRankMismatch intercepted !" & @CRLF & _
                $oSafeArrayError.data & @CRLF & _
                $oSafeArrayError.HelpLink & @CRLF & _
                $oSafeArrayError.HResult & @CRLF & _
                $oSafeArrayError.InnerException & @CRLF & _
                $oSafeArrayError.Message & @CRLF & _
                $oSafeArrayError.Source & @CRLF & _
                $oSafeArrayError.StackTrace & @CRLF & _
                $oSafeArrayError.TargetSite)
Endfunc

_Example_Hashtable()

Func _Example_Hashtable()
    Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)
    Local $oClouds = _CLR_CreateObject($oAssembly, "System.Collections.Hashtable")
    ConsoleWrite("!$oHash: " & IsObj($oClouds) & @CRLF)
        $oClouds.Add("Cirrus", "Castellanus");
        $oClouds.Add("Cirrocumulus", "Stratiformis");
        $oClouds.Add("Altostratus", "Radiatus");
        $oClouds.Add("Stratocumulus", "Perlucidus");
        $oClouds.Add("Stratus", "Fractus");
        $oClouds.Add("Nimbostratus", "Pannus");
        $oClouds.Add("Cumulus", "Humilis");
        $oClouds.Add("Cumulonimbus", "Incus");

    local $iCloudCount=$oClouds.count
;~     consolewrite("Hashtable Clouds added " & $iCloudCount & @CRLF)
	MsgBox(0,"System.Collections.Hashtable","Hashtable Clouds added " & $iCloudCount)
;~     consolewrite("It contains Fractus " & $oClouds.containsvalue("Fractus") & @CRLF)
	MsgBox(0,"System.Collections.Hashtable","It contains Fractus " &$oClouds.containsvalue("Fractus") )


EndFunc   ;==>_Example