;#AutoIt3Wrapper_UseX64=y
#include ".\Includes\CLR.au3"
#include ".\Includes\AccVarsUtilities.au3"


Example()

Func Example()
  Local $oAssembly = _CLR_LoadLibrary("System")
  ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

  Local $pAssemblyType = 0
  $oAssembly.GetType_2("System.Diagnostics.Process", $pAssemblyType)
  ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

  Local $oAssemblyType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
  ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oAssemblyType) & @CRLF)

  Local $sName = ""
  $oAssemblyType.get_FullName($sName)
  ConsoleWrite($sName & @CRLF)

  Local $sProcName[] = ["Notepad"], $pSafeArray
  AccVars_ArrayToSafeArray( $sProcName, $pSafeArray ) ; <<<<<<<<<<<<<<<<< Create SafeArray <<<<<<<<<<<<<<<<

  Local $pObject = 0, $aObject, $oProcess

  ; Run two Notepad instances
  $oAssemblyType.InvokeMember_3("Start", 0x158, 0, 0, $pSafeArray, $pObject) ; <<<<<<<<< Use SafeArray <<<<<<<<
  $oAssemblyType.InvokeMember_3("Start", 0x158, 0, 0, $pSafeArray, $pObject) ; <<<<<<<<< Use SafeArray <<<<<<<<
  Sleep(1000)

  $oAssemblyType.InvokeMember_3("GetProcessesByName", 0x158, 0, 0, $pSafeArray, $pObject)
  ConsoleWrite("$pObject: " & IsObj($pObject) & @TAB & "$pObject: " & Ptr($pObject) & @CRLF & @CRLF)

  AccVars_SafeArrayToArray( $pObject, $aObject ) ;  <<<<<<<<<<<<<<<<<<<<< Create SafeArray <<<<<<<<<<<<<<<<<<<<

  For $i = 0 To UBound( $aObject ) - 1
    $oProcess = ObjCreateInterface($aObject[$i],"",Default,False)

    ConsoleWrite("IsObj( $oProcess ) = " & IsObj($oProcess) & @CRLF)
    ConsoleWrite("-Process " & $i+1 & " Information" & @CRLF)
    ConsoleWrite("$oProcess.ProcessName : " & $oProcess.ProcessName & @CRLF)
    ConsoleWrite("$oProcess.Id : " & $oProcess.Id & @CRLF)
    ConsoleWrite("$oProcess.MainWindowTitle : " & $oProcess.MainWindowTitle & @CRLF)
    ConsoleWrite(@CRLF)

                Sleep(1000)
                $oProcess.Kill()
                $oProcess.Dispose()
  Next
EndFunc
