#include ".\Includes\CLR.au3"

Example()

Func Example()

    Local  $sAutoItX3AssemblyPath = RegRead("HKLM\SOFTWARE" & (@AutoItX64 ? "\Wow6432Node" : "") & "\AutoIt v3\AutoIt", "InstallDir") & "\AutoItX\AutoItX3.Assembly.dll"
    ConsoleWrite("AutoItX3.Assembly.dll Path: " & $sAutoItX3AssemblyPath & @CRLF)

    Local $oAssembly = _CLR_LoadLibrary($sAutoItX3AssemblyPath) ; Equals [Reflection.Assembly]::Loadfile()
    ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

    Local $pAssemblyType = 0
    $oAssembly.GetType_2("AutoIt.AutoItX", $pAssemblyType)
    ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

    Local $oAssemblyType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
    ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oAssemblyType) & @CRLF)

    Local $aText[] = ["We Love AutoIt !!"]
    Local $sClipBoardText = ""

;~     $oAssemblyType.InvokeMember_3("", 0x158, 0, 0, 0, 0)
    $oAssemblyType.InvokeMember_3("ClipPut", 0x158, 0, 0, CreateSafeArray($aText), 0)
    ConsoleWrite("Clipboard GET Data: " & ClipGet() & @CRLF)
    MsgBox(0,"[AutoIt.AutoItX]::ClipPut" , "Clipboard Data: " & ClipGet())

	Sleep (1000)
    ClipPut("AutoIt Rocks!!!")

	Local $aText[] = [0]
    $oAssemblyType.InvokeMember_3("ClipGet", 0x158, 0, 0, CreateSafeArray($aText), $sClipBoardText)
    ConsoleWrite("Clipboard PUT Data: " & $sClipBoardText & @CRLF)
    MsgBox(0,"[AutoIt.AutoItX]::ClipPut" , "New Clipboard Data: " & $sClipBoardText)

EndFunc   ;==>Example


Example1() ; WinSCP - https://winscp.net/eng/download.php

Func Example1()
    local $oActivator=getActivator()

    Local $aText[] = ["C:\_\Apps\_DotNet Scripting\.NET WinSCP Library\WinSCPnet.dll", "WinSCP.Session"] ; <<<<<<<  Set correct assembly path

    Local $pObject = 0
    $oActivator.InvokeMember_3("CreateComInstanceFrom", 0x158, 0, 0, CreateSafeArray($aText), $pObject)
    ConsoleWrite("IsObject: " & IsObj($pObject) & @TAB & "$pObject: " & ObjName($pObject) & @CRLF)

    Local $oObject = $pObject.Unwrap()
    ConsoleWrite("!$oMembership: " & IsObj($oObject) & @CRLF)
    consolewrite("!IsSession : " & $oObject.Opened & @CRLF)
	MsgBox(0,"WinSCP.Session","Session Open : " & $oObject.Opened )

EndFunc

Example2() ; DotNetZip - http://dotnetzip.codeplex.com/

Func Example2()
    local $oActivator=GetActivator()

    Local $aText[] = ["C:\_\Apps\_DOTnet Scripting\.NET Zip Library\zip-v1.9\Release\Ionic.Zip.dll", "Ionic.Zip.ComHelper"] ; <<<<<<<<<<<<< Set correct assembly path

    Local $pObject = 0
    $oActivator.InvokeMember_3("CreateComInstanceFrom", 0x158, 0, 0, CreateSafeArray($aText), $pObject)
    ConsoleWrite("IsObject: " & IsObj($pObject) & @TAB & "$pObject: " & ObjName($pObject) & @CRLF)

    Local $oObject = $pObject.Unwrap()
    ConsoleWrite("!$oObject : " & IsObj($oObject) & @CRLF)
    consolewrite("!IsZipfile : " & $oObject.IsZipFile("C:\_\Apps\_DOTnet Scripting\.NET Zip Library\DotNetZip-Documentation-v1.9.zip") & @CRLF)
    MsgBox(0,"Ionic.Zip", "GetZipLibraryVersion : " & $oObject.GetZipLibraryVersion)

EndFunc   ;==>Example


Func GetActivator()
    Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    Local $ptActivator = 0
    $oAssembly.GetType_2("System.Activator", $ptActivator)
    Local $oActivator = ObjCreateInterface($ptActivator, $sIID_IType, $sTag_IType)

;~  ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)
;~  ConsoleWrite("$pAssemblyType = " & Ptr($ptActivator) & @CRLF)
;~  ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oActivator) & @TAB & @CRLF)

    Return $oActivator
Endfunc