#include ".\Includes\CLR.au3"

; -----------------------------------------------------
; Example Using CreateComInstanceFrom System.Activator
; To access Conventional COM visible Assemblies
; Registration free (no need to REGASM
; -----------------------------------------------------


Global $sHTML = '<!DOCTYPE html>' & @CR
            $sHTML &= '<html>' & @CR
            $sHTML &= '<head>' & @CR
            $sHTML &= '<meta content="text/html; charset=UTF-8" http-equiv="content-type">' & @CR
            $sHTML &= '<title>_IE_Introduction ("basic")</title>' & @CR
            $sHTML &= '<style>body {font-family: Arial}' & @CR
            $sHTML &= 'td {padding:6px}</style>' & @CR
            $sHTML &= '</head>' & @CR
            $sHTML &= '<body>' & @CR
            $sHTML &= '<table border=1 id="table1" style="width:600px;border-spacing:6px;">' & @CR
            $sHTML &= '<tr>' & @CR
            $sHTML &= '<td>' & @CR
            $sHTML &= '<h1>Welcome to IE.au3</h1>' & @CR
            $sHTML &= 'IE.au3 is a UDF (User Defined Function) library for the ' & @CR
            $sHTML &= '<a href="http://www.autoitscript.com">AutoIt</a> scripting language.' & @CR
            $sHTML &= '<br>  ' & @CR
            $sHTML &= 'IE.au3 allows you to either create or attach to an Internet Explorer browser and do ' & @CR
            $sHTML &= 'just about anything you could do with it interactively with the mouse and ' & @CR
            $sHTML &= 'keyboard, but do it through script.' & @CR
            $sHTML &= '<br>' & @CR
            $sHTML &= 'You can navigate to pages, click links, fill and submit forms etc. You can ' & @CR
            $sHTML &= 'also do things you cannot do interactively like change or rewrite page ' & @CR
            $sHTML &= 'content and JavaScripts, read, parse and save page content and monitor and act ' & @CR
            $sHTML &= 'upon browser "events".<br>' & @CR
            $sHTML &= 'IE.au3 uses the COM interface in AutoIt to interact with the Internet Explorer ' & @CR
            $sHTML &= 'object model and the DOM (Document Object Model) supported by the browser.' & @CR
            $sHTML &= '<br>' & @CR
            $sHTML &= 'Here are some links for more information and helpful tools:<br>' & @CR
            $sHTML &= 'Reference Material: ' & @CR
            $sHTML &= '<ul>' & @CR
            $sHTML &= '<li><a href="http://msdn1.microsoft.com/">MSDN (Microsoft Developer Network)</a></li>' & @CR
            $sHTML &= '<li><a href="http://msdn2.microsoft.com/en-us/library/aa752084.aspx" target="_blank">InternetExplorer Object</a></li>' & @CR
            $sHTML &= '<li><a href="http://msdn2.microsoft.com/en-us/library/ms531073.aspx" target="_blank">Document Object</a></li>' & @CR
            $sHTML &= '<li><a href="http://msdn2.microsoft.com/en-us/ie/aa740473.aspx" target="_blank">Overviews and Tutorials</a></li>' & @CR
            $sHTML &= '<li><a href="http://msdn2.microsoft.com/en-us/library/ms533029.aspx" target="_blank">DHTML Objects</a></li>' & @CR
            $sHTML &= '<li><a href="http://msdn2.microsoft.com/en-us/library/ms533051.aspx" target="_blank">DHTML Events</a></li>' & @CR
            $sHTML &= '</ul><br>' & @CR
            $sHTML &= 'Helpful Tools: ' & @CR
            $sHTML &= '<ul>' & @CR
            $sHTML &= '<li><a href="http://www.autoitscript.com/forum/index.php?showtopic=19368" target="_blank">AutoIt IE Builder</a> (build IE scripts interactively)</li>' & @CR
            $sHTML &= '<li><a href="http://www.debugbar.com/" target="_blank">DebugBar</a> (DOM inspector, HTTP inspector, HTML validator and more - free for personal use) Recommended</li>' & @CR
            $sHTML &= '<li><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=e59c3964-672d-4511-bb3e-2d5e1db91038&amp;displaylang=en" target="_blank">IE Developer Toolbar</a> (comprehensive DOM analysis tool)</li>' & @CR
            $sHTML &= '<li><a href="http://slayeroffice.com/tools/modi/v2.0/modi_help.html" target="_blank">MODIV2</a> (view the DOM of a web page by mousing around)</li>' & @CR
            $sHTML &= '<li><a href="http://validator.w3.org/" target="_blank">HTML Validator</a> (verify HTML follows format rules)</li>' & @CR
            $sHTML &= '<li><a href="http://www.fiddlertool.com/fiddler/" target="_blank">Fiddler</a> (examine HTTP traffic)</li>' & @CR
            $sHTML &= '</ul>' & @CR
            $sHTML &= '</td>' & @CR
            $sHTML &= '</tr>' & @CR
            $sHTML &= '</table>' & @CR
            $sHTML &= '</body>' & @CR
            $sHTML &= '</html>'

Example()

Func Example()

    Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

    Local $pAssemblyType = 0
    $oAssembly.GetType_2("System.Activator", $pAssemblyType)
    ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

    Local $oAssemblyType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
    ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oAssemblyType) & @TAB & @CRLF)

    Local $aText[] = ["C:\Program Files (x86)\Microsoft.NET\Primary Interop Assemblies\Microsoft.mshtml.dll", "mshtml.HTMLDocumentClass"] ;Set correct assembly path
    Local $pObject = 0
    $oAssemblyType.InvokeMember_3("CreateComInstanceFrom", 0x158, 0, 0, CreateSafeArray($aText), $pObject)
    ConsoleWrite("IsObject: " & IsObj($pObject) & @TAB & "$pObject: " & ObjName($pObject) & @CRLF & @CRLF)

    Local $oHTMLDocumentClass = $pObject.Unwrap()
    ConsoleWrite("!$oHTMLDocumentClass: " & IsObj($oHTMLDocumentClass) & @CRLF & @CRLF)
    $oHTMLDocumentClass.write($sHTML)

    Local $oLinks=$oHTMLDocumentClass.Links
    For $oLink in $oLinks
        ConsoleWrite($oLink.ToString() & @CRLF)
    Next

EndFunc   ;==>Example