#include ".\Includes\CLR.au3"

Random1() ; CLR Approach

Func Random1()

	Local $oAssembly = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)

    local $oRnd =_CLR_CreateObject($oAssembly,"System.Random")
    ConsoleWrite("!$oRnd " & IsObj($oRnd) & @CRLF)

    MsgBox(0,".Net CLR Random #", "System.Random # : " & $oRnd.Next_2( 1, 100 ) & @CRLF)

EndFunc

Random2() ; COM Approach

Func Random2()

    $objRandom = ObjCreate( "System.Random" )
    MsgBox(0,"ObjCreate( 'System.Random' )" , "System.Random # : " & $objRandom.Next_2( 1, 100 ))
EndFunc

; --------------------------------------------------------------------
; Enum all DotNET Classes that are exposed as conventional COM Objects
; objCreate = ;0; clr = ;1 Means Not ObjCreate compatible CRL Complatible
; objCreate = ;1; clr = ;1 Means ObjCreate compatible CRL Complatible
; --------------------------------------------------------------------

Example1()

Func Example1()
    Local $oErrorHandler = ObjEvent("AutoIt.Error", "_ErrFunc")
    Local $oType = _CLR_LoadLibrary("mscorlib")
    ConsoleWrite("$oType: " & IsObj($oType) & @CRLF)

    Local $pTypes
    $oType.GetTypes($pTypes)

    Local $iDim = SafeArrayGetDim($pTypes)
    ConsoleWrite("$iDim = " & $iDim & @CRLF)

    Local $iLBound, $iUBound
    SafeArrayGetLBound($pTypes, 1, $iLBound)
    SafeArrayGetUBound($pTypes, 1, $iUBound)
    ConsoleWrite("$iLBound = " & $iLBound & @CRLF)
    ConsoleWrite("$iUBound = " & $iUBound & @CRLF)

    Local $tTypeArray = DllStructCreate($tagSAFEARRAY, $pTypes)
        Local $iPtrSize=(DllStructGetData($tTypeArray, "cbElements"))

    ConsoleWrite(".cDims = " & (DllStructGetData($tTypeArray, "cDims")) & @CRLF & @CRLF)
    ConsoleWrite(".fFeatures = 0x" & Hex(DllStructGetData($tTypeArray, "fFeatures")) & @CRLF & @CRLF)
    ConsoleWrite(".cbElements = " & $iPtrSize & @CRLF & @CRLF)

    Local $vt=0
    SafeArrayGetVartype($pTypes, $vt)
    ConsoleWrite("$vt = " & $vt  & @CRLF & @CRLF)

;~  Local $tGUID = $tagGUID
;~  Local $tGUID = DllStructCreate($tagGUID, $pTypes - 16)
;~  Local $sGUID = _WinAPI_StringFromGUID($tGUID)
;~  ConsoleWrite("$sGUID = " & $sGUID & @CRLF)

    Local $pTypeArrayData = 0
    Local $tType=0
    Local $pType=0
    Local $oType=Null
    Local $oType2=Null
    Local $sFullName=""

    SafeArrayAccessData($pTypes, $pTypeArrayData)
      For $i = 0 To $iUBound
;~         SafeArrayAccessData($pTypes, $pTypeArrayData)
        $tType = DllStructCreate("ptr", $pTypeArrayData + ($i * $iPtrSize))
        $pType = DllStructGetData($tType, 1)
;~         ConsoleWrite("+$pType = " & $pType & @CRLF)
;~         SafeArrayUnaccessData($pTypes)

        $oType = ObjCreateInterface($pType, $sIID_IType, $sTag_IType)
;~         ConsoleWrite("IsObj( $oType ) = " & IsObj($oType) & @CRLF)

        $oType.get_FullName($sFullName)

;~      See if we also can get object thru objcreate ; <<<<<<<<<<<<<<<<<<< look here !!!!
            $oType2=ObjCreate($sFullName)

            ConsoleWrite("objCreate = ;" & IsObj($oType2) & "; clr = ;" & IsObj($oType) & "; $sFullName = ;" & $sFullName & @CRLF )

;~      endIf
        $sFullName=""
        $pType= 0
        $tType=0
        $oType = Null
      Next
    SafeArrayUnaccessData($pTypes)

EndFunc   ;==>Example1

Func _ErrFunc($oError)
Endfunc