;~ #AutoIt3Wrapper_UseX64=y

#include ".\Includes\CLR.au3"
#include <WinAPI.au3>
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>

; DO THIS HERE FIRST below !!!!!

;Uncomment the example you want to Run

 _Example1() ;C# & VB Messagebox
 _Example2() ;C# Create Executable
 _Example3() ;C#Return String from Class Method
 _Example4() ;XPTable Example
 _Example5() ;A MessageBox Using System.Windows.Forms.MessageBox
 _Example6() ;WebClient.DownloadString  Using System.Net.WebClient
 _Example7() ;Form  Using System.Windows.Forms.Form
 _Example8() ;Stack Using System.Collections.Generic.Stack
 _Example9() ;File.ReadAllText Using System.IO
 _Example10() ;ArrayList Using System.Collections.ArrayList

Func _Example1()

	Local $oAssemblyCSharp = _CLR_CompileCSharp(FileRead("CodeC#.cs"), "System.dll | System.Windows.Forms.dll")
	If IsObj($oAssemblyCSharp) Then
		ConsoleWrite("$oAssemblyCSharp: " & IsObj($oAssemblyCSharp) & @CRLF)
		Local $oFoo = _CLR_CreateObject($oAssemblyCSharp, "Foo")
		ConsoleWrite("$oFoo: " & IsObj($oFoo) & @CRLF)
		If IsObj($oFoo) Then $oFoo.Test()
	EndIf

	Local $oAssemblyVB = _CLR_CompileVB(FileRead("CodeVB.cs"), "System.dll | System.Windows.Forms.dll")
	If IsObj($oAssemblyVB) Then
		ConsoleWrite("$oAssemblyVB: " & IsObj($oAssemblyVB) & @CRLF)
		Local $oFoo = _CLR_CreateObject($oAssemblyVB, "Foo")
		ConsoleWrite("$oFoo: " & IsObj($oFoo) & @CRLF)
		If IsObj($oFoo) Then $oFoo.Test()
	EndIf

EndFunc   ;==>_Example1


Func _Example2()
	Local $sCSharpExecutablePath = _CLR_CompileCSharp(FileRead("CodeC#Exe.cs"), "System.dll", 0, @ScriptDir & "\HelloWorld.exe")
	If $sCSharpExecutablePath Then
		ConsoleWrite("$sCSharpPath: " & $sCSharpExecutablePath & @CRLF)
		ShellExecute($sCSharpExecutablePath)
	EndIf
EndFunc   ;==>_Example2

Func _Example3()
	Local $oAssemblyCSharp = _CLR_CompileCSharp(FileRead("CodeC#ReturnString.cs"))
	If IsObj($oAssemblyCSharp) Then
		ConsoleWrite("$oAssemblyCSharp: " & IsObj($oAssemblyCSharp) & @CRLF)
		Local $oMainReturnValTest = _CLR_CreateObject($oAssemblyCSharp, "MainReturnValTest")
		ConsoleWrite("$oMainReturnValTest: " & IsObj($oMainReturnValTest) & @CRLF)
		If IsObj($oMainReturnValTest) Then MsgBox(0, "ReturnString", $oMainReturnValTest.Main())
	EndIf
EndFunc   ;==>_Example3



Func _Example4()

	Local $oXPTable = _CLR_LoadLibrary("XPTable.dll")
	ConsoleWrite("+Object: " & IsObj($oXPTable) & @CRLF)

	Local $oTable = _CLR_CreateObject($oXPTable, "XPTable.Models.Table")
	Local $oColumnModel = _CLR_CreateObject($oXPTable, "XPTable.Models.ColumnModel")
	Local $oTableModel = _CLR_CreateObject($oXPTable, "XPTable.Models.TableModel")
	ConsoleWrite("IsObj( $oTable ) = " & IsObj($oTable) & @CRLF)
	ConsoleWrite("IsObj( $oColumnModel ) = " & IsObj($oColumnModel) & @CRLF)
	ConsoleWrite("IsObj( $oTableModel ) = " & IsObj($oTableModel) & @CRLF)

	$oTable.ColumnModel() = $oColumnModel
	$oTable.TableModel() = $oTableModel


	Local $oColumn0 = _CLR_CreateObject($oXPTable, "XPTable.Models.TextColumn", "MyTextColumn")
	Local $oColumn1 = _CLR_CreateObject($oXPTable, "XPTable.Models.CheckBoxColumn", "CheckBoxColumn")
	Local $oColumn2 = _CLR_CreateObject($oXPTable, "XPTable.Models.ButtonColumn", "MyButtonColumn")

	ConsoleWrite("IsObj( $oColumn0 ) = " & IsObj($oColumn0) & @CRLF)
	ConsoleWrite("IsObj( $oColumn1 ) = " & IsObj($oColumn1) & @CRLF)
	ConsoleWrite("IsObj( $oColumn2 ) = " & IsObj($oColumn2) & @CRLF)

	$oColumnModel.Columns.Add($oColumn0)
	$oColumnModel.Columns.Add($oColumn1)
	$oColumnModel.Columns.Add($oColumn2)
	ConsoleWrite("VisibleColumnCount = " & $oColumnModel.VisibleColumnCount() & @CRLF)

	Local $oRow = _CLR_CreateObject($oXPTable, "XPTable.Models.Row")
	ConsoleWrite("IsObj( $oRow ) = " & IsObj($oRow) & @CRLF)
	$oTableModel.Rows.Add($oRow)
	ConsoleWrite("Rows = " & $oTableModel.Rows.Count() & @CRLF)

	Local $oCell0 = _CLR_CreateObject($oXPTable, "XPTable.Models.Cell", "MyCell1")
	Local $oCell1 = _CLR_CreateObject($oXPTable, "XPTable.Models.Cell", "MyCheckbox1")
	Local $oCell2 = _CLR_CreateObject($oXPTable, "XPTable.Models.Cell", "MyButton1")

	ConsoleWrite("IsObj( $oCell0 ) = " & IsObj($oCell0) & @CRLF)
	ConsoleWrite("IsObj( $oCell1 ) = " & IsObj($oCell1) & @CRLF)
	ConsoleWrite("IsObj( $oCell2 ) = " & IsObj($oCell2) & @CRLF)

	$oTableModel.Rows.Item(0).Cells.Add($oCell0)
	$oTableModel.Rows.Item(0).Cells.Add($oCell1)
	$oTableModel.Rows.Item(0).Cells.Add($oCell2)
	ConsoleWrite("Cells = " & $oTableModel.Rows.Item(0).Cells.Count() & @CRLF)

	$oTable.Left() = 10
	$oTable.Top() = 10
	$oTable.Width() = 300
	$oTable.Height() = 200

	Local $hTable = $oTable.Handle()
	Local $hGui = GUICreate("XPTable", 320, 220)
	_WinAPI_SetParent($hTable, $hGui)
	GUISetState()
	Do
	Until GUIGetMsg() = -3 ; $GUI_EVENT_CLOSE

EndFunc   ;==>_Example4

Func _Example5()
	Local $oAssembly = _CLR_LoadLibrary("System.Windows.Forms")
	ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

	Local $pAssemblyType = 0
	$oAssembly.GetType_2("System.Windows.Forms.MessageBox", $pAssemblyType)
	ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

	Local $oAssemblyType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
	ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oAssemblyType) & @CRLF)


	Local $tSafeArrayBound = DllStructCreate($tagSAFEARRAYBOUND)
	Local $pSafeArray, $pSafeArrayData
	DllStructSetData($tSafeArrayBound, "cElements", 1)
	DllStructSetData($tSafeArrayBound, "lLbound", 0)
	$pSafeArray = SafeArrayCreate($VT_VARIANT, 1, $tSafeArrayBound)
	SafeArrayAccessData($pSafeArray, $pSafeArrayData)
	DllStructSetData(DllStructCreate("word", $pSafeArrayData), 1, $VT_BSTR)
	DllStructSetData(DllStructCreate("ptr", $pSafeArrayData + 8), 1, SysAllocString("This is a MessageBox :-)"))
	SafeArrayUnaccessData($pSafeArray)

	Local $pObject = 0
	$oAssemblyType.InvokeMember_3("Show", 0x158, 0, 0, $pSafeArray, $pObject)

EndFunc   ;==>_Example5


Func _Example6()
	Local $oAssembly = _CLR_LoadLibrary("System.Net")
	ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)
	Local $oWebClient = _CLR_CreateObject($oAssembly, "System.Net.WebClient")
	ConsoleWrite("!$oWebClient: " & IsObj($oWebClient) & @CRLF)
	Local $sString = $oWebClient.DownloadString("http://checkip.dyndns.org")
	ConsoleWrite("!" & $sString & @CRLF)
	$sString = StringRegExp($sString, '((?:\d{1,3}\.){3}\d{1,3})', 3)
	MsgBox(0, "WebClient.DownloadString", "Current IP Address: " & (IsArray($sString) ? $sString[0] : "Ups something was wrong... :("))
EndFunc   ;==>_Example6

Func _Example7()
	Local $oAssembly = _CLR_LoadLibrary("System.Windows.Forms")
	ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)
	Local $oForm = _CLR_CreateObject($oAssembly, "System.Windows.Forms.Form")
	ConsoleWrite("!$oForm: " & IsObj($oForm) & @CRLF)
	$oForm.Text = "Form From Net - AutoIt Rocks"
	$oForm.Width = 800
	$oForm.Height = 400
	$oForm.Show()
	Sleep(1000)
	ConsoleWrite("$oForm Handle: " & $oForm.Handle & @CRLF)
	Local $hGui, $hGraphic, $hPen
	$hGui = $oForm.Handle
	_GDIPlus_Startup()
	Local $hGraphics = _GDIPlus_GraphicsCreateFromHWND($hGui)
	Local $hBmp_Buffer = _GDIPlus_BitmapCreateFromGraphics(800, 400, $hGraphics)
	Local $hGfx_Buffer = _GDIPlus_ImageGetGraphicsContext($hBmp_Buffer)
	_GDIPlus_GraphicsSetSmoothingMode($hGfx_Buffer, $GDIP_SMOOTHINGMODE_HIGHQUALITY)
	_GDIPlus_GraphicsClear($hGfx_Buffer, 0xFF000000)

	Local $hPath = _GDIPlus_PathCreate()
	Local $hFormat = _GDIPlus_StringFormatCreate()
	_GDIPlus_StringFormatSetAlign($hFormat, 1)
	Local $hFamily = _GDIPlus_FontFamilyCreate("Arial")
	Local $tLayout = _GDIPlus_RectFCreate(0, 0, 800, 400)
	_GDIPlus_PathAddString($hPath, "AutoIt rulez!", $tLayout, $hFamily, 0, 140, $hFormat)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_FontFamilyDispose($hFamily)

	Local $aPoints[5][2] = [[4]]
	$aPoints[1][0] = 0
	$aPoints[1][1] = 0
	$aPoints[2][0] = 20
	$aPoints[2][1] = 0
	$aPoints[3][0] = 20
	$aPoints[3][1] = 20
	$aPoints[4][0] = 0
	$aPoints[4][1] = 20

	Local $aColors[4] = [3]
	$aColors[1] = 0xFFFF0000
	$aColors[2] = 0xFF00FF00
	$aColors[3] = 0xFF0000FF

	Local $hMatrix = _GDIPlus_MatrixCreate()
	_GDIPlus_MatrixRotate($hMatrix, 1, True)

	Local $hBrush, $hPen

	Local $hTimer = TimerInit()
	Local $hTimerExit = TimerInit()

	; Loop until the user exits.
	While 1
		If TimerDiff($hTimerExit) > 5000 Then ExitLoop
		If TimerDiff($hTimer) > 40 Then
			_GDIPlus_MatrixTransformPoints($hMatrix, $aPoints)

			$hBrush = _GDIPlus_PathBrushCreate($aPoints, 3)
			_GDIPlus_PathBrushSetCenterColor($hBrush, 0xFFFFFFFF)
			_GDIPlus_PathBrushSetSurroundColorsWithCount($hBrush, $aColors)
			$hPen = _GDIPlus_PenCreate2($hBrush, 6)
			_GDIPlus_PenSetLineJoin($hPen, $GDIP_PENSETLINEJOIN_ROUND)
			_GDIPlus_BrushDispose($hBrush)

			_GDIPlus_GraphicsClear($hGfx_Buffer, 0xFF000000)
			_GDIPlus_GraphicsDrawPath($hGfx_Buffer, $hPath, $hPen)
			_GDIPlus_PenDispose($hPen)

			_GDIPlus_GraphicsDrawImage($hGraphics, $hBmp_Buffer, 0, 0)
			$hTimer = TimerInit()
		EndIf
	WEnd

	; Clean up resources
	_GDIPlus_PathDispose($hPath)
	_GDIPlus_MatrixDispose($hMatrix)
	_GDIPlus_GraphicsDispose($hGfx_Buffer)
	_GDIPlus_BitmapDispose($hBmp_Buffer)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
EndFunc   ;==>_Example7





Func _Example8()
	Local $oAssembly = _CLR_LoadLibrary("mscorlib")
	ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)
	Local $oStack = _CLR_CreateObject($oAssembly, "System.Collections.Stack")
	ConsoleWrite("!$oStack: " & IsObj($oStack) & @CRLF)
	$oStack.Push("Bye Bye...")
	$oStack.Push("I Love AutoIt...")
	$oStack.Push("AutoIt Rocks...")
	For $i = 0 To $oStack.Count() - 1
		MsgBox(0, "Stack Example", $oStack.Pop())
	Next
EndFunc   ;==>_Example8


Func _Example9()

	Local $oAssembly = _CLR_LoadLibrary("mscorlib")
	ConsoleWrite("$oAssembly: " & IsObj($oAssembly) & @CRLF)

	Local $pAssemblyType = 0
	$oAssembly.GetType_2("System.IO.File", $pAssemblyType)
	ConsoleWrite("$pAssemblyType = " & Ptr($pAssemblyType) & @CRLF)

	Local $oAssemblyType = ObjCreateInterface($pAssemblyType, $sIID_IType, $sTag_IType)
	ConsoleWrite("IsObj( $oAssemblyType ) = " & IsObj($oAssemblyType) & @CRLF)

	Local $tSafeArrayBound = DllStructCreate($tagSAFEARRAYBOUND)
	Local $pSafeArray, $pSafeArrayData
	DllStructSetData($tSafeArrayBound, "cElements", 1)
	DllStructSetData($tSafeArrayBound, "lLbound", 0)
	$pSafeArray = SafeArrayCreate($VT_VARIANT, 1, $tSafeArrayBound)
	SafeArrayAccessData($pSafeArray, $pSafeArrayData)
	DllStructSetData(DllStructCreate("word", $pSafeArrayData), 1, $VT_BSTR)
	DllStructSetData(DllStructCreate("ptr", $pSafeArrayData + 8), 1, SysAllocString(@ScriptDir & "\CodeC#.cs"))
	SafeArrayUnaccessData($pSafeArray)
	Local $sString = 0
	$oAssemblyType.InvokeMember_3("ReadAllText", 0x158, 0, 0, $pSafeArray, $sString)
	MsgBox(0, "File.ReadAllText", $sString)
EndFunc   ;==>_Example9

Func _Example10()
	Local $oAssembly = _CLR_LoadLibrary("mscorlib")
	ConsoleWrite("!$oAssembly: " & IsObj($oAssembly) & @CRLF)
	Local $oArrayList = _CLR_CreateObject($oAssembly, "System.Collections.ArrayList")
	ConsoleWrite("!$oArrayList: " & IsObj($oArrayList) & @CRLF)
	Local $sString = "No Sorted Array: " & @CRLF

	For $i = 0 To 30 - 1
		$oArrayList.Add(Chr(Random(65, 90, 1)))
		$sString &= $oArrayList.item($i) & @CRLF
	Next
	MsgBox(0, "No Sorted Array", $sString)
	$oArrayList.Sort()

	$sString = "Sorted Array" & @CRLF
	For $i = 0 To 30 - 1
		$oArrayList.Add(Random(1, 100, 1))
		$sString &= $oArrayList.item($i) & @CRLF
	Next
	MsgBox(0, "Sorted Array", $sString)

EndFunc   ;==>_Example10

