;#AutoIt3Wrapper_UseX64=y

#include ".\Includes\CLR.au3"

Global Const $S_OK = 0

Example()

Func Example()
  Local $hMSCorEE = DllOpen("MSCorEE.DLL")
  Local $aRet = DllCall($hMSCorEE, "long", "CLRCreateInstance", "struct*", $tCLSID_CLRMetaHost, "struct*", $tIID_ICLRMetaHost, "ptr*", 0)

  If $aRet[0] = $S_OK Then
    Local $pClrHost = $aRet[3]
    Local $oClrHost = ObjCreateInterface($pClrHost, $sIID_ICLRMetaHost, $sTag_ICLRMetaHost)
    ConsoleWrite(">oClrHost: " & IsObj($oClrHost) & @CRLF)

    Local $sNETFrameworkVersion = "v4.0.30319"
    Local $tCLRRuntimeInfo = DllStructCreate("ptr")
    $oClrHost.GetRuntime($sNETFrameworkVersion, $tIID_ICLRRuntimeInfo, DllStructGetPtr($tCLRRuntimeInfo))
    Local $pCLRRuntimeInfo = DllStructGetData($tCLRRuntimeInfo, 1)
    ConsoleWrite(">pCLRRuntimeInfo: " & $pCLRRuntimeInfo & @CRLF)

    Local $oCLRRuntimeInfo = ObjCreateInterface($pCLRRuntimeInfo, $sIID_ICLRRuntimeInfo, $sTag_ICLRRuntimeInfo)
    ConsoleWrite(">oCLRRuntimeInfo: " & IsObj($oCLRRuntimeInfo) & @CRLF)
    Local $isIsLoadable = 0
    $oCLRRuntimeInfo.IsLoadable($isIsLoadable)
    ConsoleWrite(">IsLoadable: " & $isIsLoadable & @CRLF)

    If $isIsLoadable Then
      Local $tCLRRuntimeHost = DllStructCreate("ptr")
      $oCLRRuntimeInfo.GetInterface(DllStructGetPtr($tCLSID_CLRRuntimeHost), DllStructGetPtr($tIID_ICLRRuntimeHost), DllStructGetPtr($tCLRRuntimeHost))
      Local $pCLRRuntimeHost = DllStructGetData($tCLRRuntimeHost, 1)
      ConsoleWrite(">pCLRRuntimeHost: " & $pCLRRuntimeHost & @CRLF)
      Local $oCLRRuntimeHost = ObjCreateInterface($pCLRRuntimeHost, $sIID_ICLRRuntimeHost, $sTag_ICLRRuntimeHost)
      ConsoleWrite(">oCLRRuntimeHost: " & IsObj($oCLRRuntimeHost) & @CRLF)

      $oCLRRuntimeHost.Start()

      ;Local $iRet = 0
      ;$oCLRRuntimeHost.ExecuteInDefaultAppDomain(@ScriptDir & "\C#Library.dll", "ClassLibraryDemo.ClassDemo", "NetMsgBox", "AutoIt Rocks!!! " & @CRLF & "Danyfirex does too lol!!!", $iRet)
      ;ConsoleWrite(">Ret: " & $iRet & @CRLF)

      Local $tCorRuntimeHost = DllStructCreate("ptr")
      $oCLRRuntimeInfo.GetInterface(DllStructGetPtr($tCLSID_CorRuntimeHost), DllStructGetPtr($tIID_ICorRuntimeHost), DllStructGetPtr($tCorRuntimeHost))
      Local $pCorRuntimeHost = DllStructGetData($tCorRuntimeHost, 1)
      ;ConsoleWrite("$pCorRuntimeHost = " & $pCorRuntimeHost & @CRLF)

      Local $oCorRuntimeHost = ObjCreateInterface($pCorRuntimeHost, $sIID_ICorRuntimeHost, $sTag_ICorRuntimeHost)
      ConsoleWrite("IsObj( $oCorRuntimeHost ) = " & IsObj($oCorRuntimeHost) & @CRLF)

      $oCorRuntimeHost.Start()

      ; tst01.ahk
      ; CLR_LoadLibrary
      ; assembly := typeofAssembly.InvokeMember_3("LoadWithPartialName", 0x158, null, null, args)

      Local $pAppDomain = 0
      $oCorRuntimeHost.GetDefaultDomain($pAppDomain)
      ConsoleWrite("$pAppDomain = " & Ptr($pAppDomain) & @CRLF)

      Local $oAppDomain = ObjCreateInterface($pAppDomain, $sIID_IAppDomain, $sTag_IAppDomain)
      ConsoleWrite("IsObj( $oAppDomain ) = " & IsObj($oAppDomain) & @CRLF)

      Local $pType
      $oAppDomain.GetType( $pType )
      ConsoleWrite( "$pType = " & Ptr( $pType ) & @CRLF )

      Local $oType = ObjCreateInterface( $pType, $sIID_IType, $sTag_IType )
      ConsoleWrite( "IsObj( $oType ) = " & IsObj( $oType ) & @CRLF )

      Local $pAssembly
      $oType.get_Assembly( $pAssembly )
      ConsoleWrite( "$pAssembly = " & Ptr( $pAssembly ) & @CRLF )

      Local $oAssembly = ObjCreateInterface( $pAssembly, $sIID_IAssembly, $sTag_IAssembly )
      ConsoleWrite( "IsObj( $oAssembly ) = " & IsObj( $oAssembly ) & @CRLF )

      Local $pAssemblyType
      $oAssembly.GetType( $pAssemblyType )
      ConsoleWrite( "$pAssemblyType = " & Ptr( $pAssemblyType ) & @CRLF )

      Local $oAssemblyType = ObjCreateInterface( $pAssemblyType, $sIID_IType, $sTag_IType )
      ConsoleWrite( "IsObj( $oAssemblyType ) = " & IsObj( $oAssemblyType ) & @CRLF )

      ; args := ComObjArray(0xC, 1),  args[0] := "System"
      Local $tSafeArrayBound = DllStructCreate( $tagSAFEARRAYBOUND )
      Local $pSafeArray, $pSafeArrayData
      DllStructSetData( $tSafeArrayBound, "cElements", 1 )
      DllStructSetData( $tSafeArrayBound, "lLbound", 0 )
      $pSafeArray =  SafeArrayCreate( $VT_VARIANT, 1, $tSafeArrayBound )
      SafeArrayAccessData( $pSafeArray, $pSafeArrayData )
      DllStructSetData( DllStructCreate( "word", $pSafeArrayData ), 1, $VT_BSTR )
      DllStructSetData( DllStructCreate( "ptr", $pSafeArrayData + 8 ), 1, SysAllocString( "System" ) )
      SafeArrayUnaccessData( $pSafeArray )

      Local $pAsmProvider
      $oAssemblyType.InvokeMember_3( "LoadWithPartialName", 0x158, 0, 0, $pSafeArray, $pAsmProvider )
      ; 0x158 = $BindingFlags_Static + $BindingFlags_Public + $BindingFlags_FlattenHierarchy + $BindingFlags_InvokeMethod
      ConsoleWrite( "$pAsmProvider = " & Ptr( $pAsmProvider ) & @CRLF )

      Local $oAsmProvider = ObjCreateInterface( $pAsmProvider, $sIID_IAssembly, $sTag_IAssembly )
      ConsoleWrite( "IsObj( $oAsmProvider ) = " & IsObj( $oAsmProvider ) & @CRLF )

      ; codeProvider := asmProvider.CreateInstance("Microsoft.CSharp.CSharpCodeProvider")
      Local $oCodeProvider
      $oAsmProvider.CreateInstance( "Microsoft.CSharp.CSharpCodeProvider", $oCodeProvider )
      ConsoleWrite( "IsObj( $oCodeProvider ) = " & IsObj( $oCodeProvider ) & @CRLF )

      ; codeCompiler := codeProvider.CreateCompiler()
      Local $oCodeCompiler = $oCodeProvider.CreateCompiler()
      ConsoleWrite( "IsObj( $oCodeCompiler ) = " & IsObj( $oCodeCompiler ) & @CRLF )

      Local $oAsmSystem = $oAsmProvider

      ; Convert | delimited list of references into an array.
      ; References = "System.dll | System.Management.dll | System.Windows.Forms.dll"
      ; StringSplit, Refs, References, |, %A_Space%%A_Tab%
      ; aRefs := ComObjArray(8, Refs0)
      ; Loop % Refs0
      ;   aRefs[A_Index-1] := Refs%A_Index%
      Local $tSafeArray1Bound = DllStructCreate( $tagSAFEARRAYBOUND )
      Local $pSafeArray1, $pSafeArray1Data
      DllStructSetData( $tSafeArray1Bound, "cElements", 3 )
      DllStructSetData( $tSafeArray1Bound, "lLbound", 0 )
      $pSafeArray1 =  SafeArrayCreate( $VT_BSTR, 1, $tSafeArray1Bound )
      SafeArrayAccessData( $pSafeArray1, $pSafeArray1Data )
      DllStructSetData( DllStructCreate( "ptr", $pSafeArray1Data ), 1, SysAllocString( "System.dll" ) )
      $pSafeArray1Data += @AutoItX64 ? 8 : 4
      DllStructSetData( DllStructCreate( "ptr", $pSafeArray1Data ), 1, SysAllocString( "System.Management.dll" ) )
      $pSafeArray1Data += @AutoItX64 ? 8 : 4
      DllStructSetData( DllStructCreate( "ptr", $pSafeArray1Data ), 1, SysAllocString( "System.Windows.Forms.dll" ) )
      SafeArrayUnaccessData( $pSafeArray1 )

      ; prms := CLR_CreateObject(asmSystem, "System.CodeDom.Compiler.CompilerParameters", aRefs)

      ; args := ComObjArray(0xC, 1),  args[0] := "XPTable.dll"
      Local $tSafeArray2Bound = DllStructCreate( $tagSAFEARRAYBOUND )
      Local $pSafeArray2, $pSafeArray2Data
      DllStructSetData( $tSafeArray2Bound, "cElements", 1 )
      DllStructSetData( $tSafeArray2Bound, "lLbound", 0 )
      $pSafeArray2 =  SafeArrayCreate( $VT_VARIANT, 1, $tSafeArray2Bound )
      SafeArrayAccessData( $pSafeArray2, $pSafeArray2Data )
      DllStructSetData( DllStructCreate( "word", $pSafeArray2Data ), 1, $VT_BSTR + $VT_ARRAY )
      DllStructSetData( DllStructCreate( "ptr", $pSafeArray2Data + 8 ), 1, $pSafeArray1 )
      SafeArrayUnaccessData( $pSafeArray2 )

      ; static Array_Empty := ComObjArray(0xC,0), null := ComObject(13,0)
      Local $pSAEmpty, $tSAB = DllStructCreate( $tagSAFEARRAYBOUND )
      DllStructSetData( $tSAB, "cElements", 0 )
      DllStructSetData( $tSAB, "lLbound", 0 )
      $pSAEmpty =  SafeArrayCreate( $VT_VARIANT, 0, $tSAB )

      Local $oPrms
      $oAsmSystem.CreateInstance_3( "System.CodeDom.Compiler.CompilerParameters", True, 0, 0, $pSafeArray2, 0, $pSAEmpty, $oPrms )
      ConsoleWrite( "IsObj( $oPrms ) = " & IsObj( $oPrms ) & @CRLF )

#Region Load Dynamic Code
      Local $sCode = FileRead( "Code.cs" )
      ConsoleWrite( "$sCode = " & @CRLF & $sCode )
#EndRegion Load Dynamic Code

      ; Compile!
      ; compilerRes := codeCompiler.CompileAssemblyFromSource(prms, Code)
      Local $oCompilerRes = $oCodeCompiler.CompileAssemblyFromSource( $oPrms, $sCode )
      ConsoleWrite( "IsObj( $oCompilerRes ) = " & IsObj( $oCompilerRes ) & @CRLF )

      Local $pCodeAssembly = $oCompilerRes.CompiledAssembly()
      ConsoleWrite( "$pCodeAssembly = " & Ptr( $pCodeAssembly ) & @CRLF )

      Local $oCodeAssembly = ObjCreateInterface( $pCodeAssembly, $sIID_IAssembly, $sTag_IAssembly )
      ConsoleWrite( "IsObj( $oCodeAssembly ) = " & IsObj( $oCodeAssembly ) & @CRLF )

      Local $oCodeObject
      $oCodeAssembly.CreateInstance_2( "Foo", True, $oCodeObject )
      ConsoleWrite( "IsObj( $oCodeObject ) = " & IsObj( $oCodeObject ) & @CRLF )

      Local $sKram = $oCodeObject.Test( "Win32_Processor" )
      $sKram = StringReplace( $sKram, "/n", @CRLF )
      MsgBox( 0, "", $sKram )
    EndIf

  EndIf

  DllClose($hMSCorEE)
EndFunc