#AutoIt3Wrapper_UseX64=n
#include ".\Includes\CLR.Au3"
#include <StructureConstants.au3>
#include <WinAPI.au3>


; If it Crashes see post 88 on how to correct it...
#cs Replace :
"GetAssemblies hresult();" & _
"get_FullName hresult();" & _ ; (Two lines)
	With
"GetAssemblies hresult(ptr*);" & _
"get_FullName hresult(bstr*);" & _ ; (Two lines)
#ce

Example_GetAssemblies()

Func Example_GetAssemblies()
  Local $oDomain=_CLR_GetDefaultDomain()
  ConsoleWrite("$oDomain: " & IsObj($oDomain) & @CRLF)

  ;Local $oXPTable = _CLR_LoadLibrary("XPTable.dll")
  Local $oXPTable = _CLR_LoadLibrary("C:\Windows\Microsoft.NET\Framework\v4.0.30319\System.Reflection.dll")

  Local $sFullName
  $oXPTable.get_FullName( $sFullName )
  ConsoleWrite(@CRLF)
  ConsoleWrite( "$sFullName = " & $sFullName & @CRLF & @CRLF )

  Local $pAssemblyArray
  $oDomain.getAssemblies( $pAssemblyArray )

  Local $iDim = SafeArrayGetDim( $pAssemblyArray )
  ConsoleWrite( "$iDim = " & $iDim & @CRLF & @CRLF )

  Local $iLBound, $iUBound
  SafeArrayGetLBound( $pAssemblyArray, 1, $iLBound )
  SafeArrayGetUBound( $pAssemblyArray, 1, $iUBound )
  ConsoleWrite( "$iLBound = " & $iLBound & @CRLF )
  ConsoleWrite( "$iUBound = " & $iUBound & @CRLF )

  Local $tAssemblyArray = DllStructCreate( $tagSAFEARRAY, $pAssemblyArray )
  Local $fFeatures = DllStructGetData( $tAssemblyArray, "fFeatures" )
  ConsoleWrite( "$fFeatures = 0x" & Hex( $fFeatures ) & @CRLF & @CRLF )

  Local $vt
  SafeArrayGetVartype( $pAssemblyArray, $vt )
  ConsoleWrite( "$vt = " & $vt & @CRLF & @CRLF )

  Local $tGUID = $tagGUID
  Local $tGUID = DllStructCreate( $tagGUID, $pAssemblyArray - 16 )
  Local $sGUID = _WinAPI_StringFromGUID( $tGUID )
  ConsoleWrite( "$sGUID = " & $sGUID & @CRLF & @CRLF )

  Local $pAssemblyArrayData
  SafeArrayAccessData( $pAssemblyArray, $pAssemblyArrayData )
  Local $tAssembly = DllStructCreate( "ptr", $pAssemblyArrayData )
  Local $pAssembly = DllStructGetData( $tAssembly, 1 )
  ConsoleWrite( "$pAssembly = " & $pAssembly & @CRLF & @CRLF )
  SafeArrayUnaccessData( $pAssemblyArray )

  Local $oAssembly = ObjCreateInterface( $pAssembly, $sIID_IAssembly, $sTag_IAssembly )
  ConsoleWrite( "IsObj( $oAssembly ) = " & IsObj( $oAssembly ) & @CRLF & @CRLF )

  Local $sFullName
  $oAssembly.get_FullName( $sFullName )
  ConsoleWrite( "$sFullName = " & $sFullName & @CRLF & @CRLF )

EndFunc