;#AutoIt3Wrapper_UseX64=y

Global Const $S_OK = 0

Global Const $sTag_CLRMetaHost = _
  "GetRuntime hresult(wstr;struct*;ptr);" & _
  "GetVersionFromFile hresult(ptr;ptr;ptr);" & _
  "EnumerateInstalledRuntimes hresult(ptr);" & _
  "EnumerateLoadedRuntimes hresult(ptr;ptr);" & _
  "RequestRuntimeLoadedNotification hresult(ptr,ptr,ptr):" & _
  "QueryLegacyV2RuntimeBinding hresult(ptr;ptr);" & _
  "ExitProcess hresult(int);"

Global Const $sTagCLRRuntimeInfo = "GetVersionString hresult(ptr;ptr);" & _
        "GetRuntimeDirectory hresult(ptr;ptr);" & _
        "IsLoaded hresult(ptr;ptr);" & _
        "LoadErrorString hresult(ptr;ptr;ptr;ptr);" & _
        "LoadLibrary hresult(ptr;ptr);" & _
        "GetProcAddress hresult(ptr;ptr);" & _
        "GetInterface hresult(ptr;ptr;ptr);" & _
        "IsLoadable hresult(Bool*);" & _
        "SetDefaultStartupFlags hresult(ptr;ptr);" & _
        "GetDefaultStartupFlags hresult(ptr;ptr;ptr);" & _
        "BindAsLegacyV2Runtime hresult();" & _
        "IsStarted hresult(ptr;ptr);"

Global Const $sTag_CLRRuntimeInfo = _
  "GetVersionString hresult(ptr;ptr);" & _
  "GetRuntimeDirectory hresult(ptr;ptr);" & _
  "IsLoaded hresult(ptr;ptr);" & _
  "LoadErrorString hresult(ptr;ptr;ptr;ptr);" & _
  "LoadLibrary hresult(ptr;ptr);" & _
  "GetProcAddress hresult(ptr;ptr);" & _
  "GetInterface hresult(ptr;ptr;ptr);" & _
  "IsLoadable hresult(Bool*);" & _
  "SetDefaultStartupFlags hresult(ptr;ptr);" & _
  "GetDefaultStartupFlags hresult(ptr;ptr;ptr);" & _
  "BindAsLegacyV2Runtime hresult();" & _
  "IsStarted hresult(ptr;ptr);"

Global Const $sTag_CLRRuntimeHost = _
  "Start hresult();" & _
  "Stop hresult();" & _
  "SetHostControl hresult(ptr);" & _
  "GetCLRControl hresult(ptr*);" & _
  "UnloadAppDomain hresult(ptr;ptr);" & _
  "ExecuteInAppDomain hresult(ptr;ptr;ptr);" & _
  "GetCurrentAppDomainId hresult(ptr);" & _
  "ExecuteApplication hresult(ptr;ptr;ptr;ptr;ptr;ptr);" & _
  "ExecuteInDefaultAppDomain hresult(wstr;wstr;wstr;wstr;ptr*);"

Global Const $sTagEnumUnknown = "Next hresult(ulong;ptr*;ulong); Skip hresult(ptr); Reset hresult(); Clone hresult(ptr);"

#Region CLSID & IID
Global Const $sCLSID_CLRMetaHost = "{9280188d-0e8e-4867-b30c-7fa83884e8de}"
Global Const $sIID_ICLRMetaHost = "{d332db9e-b9b3-4125-8207-a14884f53216}"
Global Const $sIID_ICLRRuntimeInfo = "{BD39D1D2-BA2F-486a-89B0-B4B0CB466891}"
Global Const $sCLSID_CLRRuntimeHost = "{90F1A06E-7712-4762-86B5-7A5EBA6BDB02}"
Global Const $sIID_ICLRRuntimeHost = "{90F1A06C-7712-4762-86B5-7A5EBA6BDB02}"
Global Const $sIID_IEnumUnknown = "{00000100-0000-0000-C000-000000000046}"

Global $tCLSID_CLRMetaHost = _WinAPI_CLSIDFromString($sCLSID_CLRMetaHost)
Global $tIID_ICLRMetaHost = _WinAPI_CLSIDFromString($sIID_ICLRMetaHost)
Global $tIID_ICLRRuntimeInfo = _WinAPI_CLSIDFromString($sIID_ICLRRuntimeInfo)
Global $tCLSID_CLRRuntimeHost = _WinAPI_CLSIDFromString($sCLSID_CLRRuntimeHost)
Global $tIID_ICLRRuntimeHost = _WinAPI_CLSIDFromString($sIID_ICLRRuntimeHost)
Global $tIID_IEnumUnknown = _WinAPI_CLSIDFromString($sIID_IEnumUnknown)
#EndRegion CLSID & IID

Local $hMSCorEE = DllOpen("MSCorEE.DLL")
Local $aRet = DllCall($hMSCorEE, "long", "CLRCreateInstance", "struct*", $tCLSID_CLRMetaHost, "struct*", $tIID_ICLRMetaHost, "ptr*", 0)

If $aRet[0] = $S_OK Then
  Local $pClrHost = $aRet[3]
  Local $oClrHost = ObjCreateInterface($pClrHost, $sIID_ICLRMetaHost, $sTag_CLRMetaHost)
  ConsoleWrite("> oClrHost: " & IsObj($oClrHost) & @CRLF)

#Region Get EnumerateRuntimes
    Local $tEnumerateRuntimes = DllStructCreate("ptr")
    $oClrHost.EnumerateInstalledRuntimes(DllStructGetPtr($tEnumerateRuntimes))
    Local $pEnumerateRuntimes = DllStructGetData($tEnumerateRuntimes, 1)
    ConsoleWrite("> pEnumerateRuntimes: " & $pEnumerateRuntimes & @CRLF)

    Local $oEnumerateRuntimes = ObjCreateInterface($pEnumerateRuntimes, $sIID_IEnumUnknown, $sTagEnumUnknown)
    ConsoleWrite("> oEnumerateRuntimes: " & IsObj($oEnumerateRuntimes) & @CRLF & @CRLF)
    Local $pRuntime = 0
    Local $oRunInfo = 0
    Local $tSize = 0
    Local $tString = 0
    ;List Runtimes
    While $oEnumerateRuntimes.Next(1, $pRuntime, Null) = $S_OK
        $oRunInfo = ObjCreateInterface($pRuntime, $sIID_ICLRRuntimeInfo, $sTagCLRRuntimeInfo)
;~      ConsoleWrite(">oRunInfo: " & IsObj($oRunInfo) & @CRLF)

	  #Region Get GetVersionString
        $tSize = DllStructCreate("dword Data")
        $tSize.Data = 0
        $oRunInfo.GetVersionString(Null, DllStructGetPtr($tSize, 1)) ;get required Size
;~      ConsoleWrite(">Required Size: " & $tSize.Data & @CRLF)
        $tString = DllStructCreate("wchar Data[" & $tSize.Data & "]")
        $oRunInfo.GetVersionString(DllStructGetPtr($tString, 1), DllStructGetPtr($tSize, 1)) ;get Version String
        ConsoleWrite("+Version String: " & $tString.Data & @CRLF)
      #EndRegion Get GetVersionString
    WEnd
#EndRegion Get EnumerateRuntimes

        ConsoleWrite( @CRLF)

  Local $sNETFrameworkVersion = "v4.0.30319"
  Local $tCLRRuntimeInfo = DllStructCreate("ptr")

  $oClrHost.GetRuntime($sNETFrameworkVersion, $tIID_ICLRRuntimeInfo, DllStructGetPtr($tCLRRuntimeInfo))
  Local $pCLRRuntimeInfo = DllStructGetData($tCLRRuntimeInfo, 1)
  ConsoleWrite("> pCLRRuntimeInfo: " & $pCLRRuntimeInfo & @CRLF)

  Local $oCLRRuntimeInfo = ObjCreateInterface($pCLRRuntimeInfo, $sIID_ICLRRuntimeInfo, $sTag_CLRRuntimeInfo)
  ConsoleWrite("> oCLRRuntimeInfo: " & IsObj($oCLRRuntimeInfo)  & @CRLF)
  Local $isIsLoadable = 0
  $oCLRRuntimeInfo.IsLoadable($isIsLoadable)
  ConsoleWrite("> IsLoadable: " & $isIsLoadable & @CRLF)

#Region Get GetVersionString
    Local $tSize = DllStructCreate("dword Data")
    $tSize.Data = 0
    $oRunInfo.GetVersionString(Null, DllStructGetPtr($tSize, 1)) ;get requiered Size
    ConsoleWrite("> Required Size: " & $tSize.Data & @CRLF)
    Local $tString = DllStructCreate("wchar Data[" & $tSize.Data & "]")
    $oRunInfo.GetVersionString(DllStructGetPtr($tString, 1), DllStructGetPtr($tSize, 1)) ;get Version String
	ConsoleWrite( @CRLF)
    ConsoleWrite("+Version String: " & $tString.Data & @CRLF & @CRLF)
#EndRegion  Get GetVersionString

  If $isIsLoadable Then
    Local $tCLRRuntimeHost = DllStructCreate("ptr")
    $oCLRRuntimeInfo.GetInterface(DllStructGetPtr($tCLSID_CLRRuntimeHost), DllStructGetPtr($tIID_ICLRRuntimeHost), DllStructGetPtr($tCLRRuntimeHost))
    Local $pCLRRuntimeHost = DllStructGetData($tCLRRuntimeHost, 1)
    ConsoleWrite("> pCLRRuntimeHost: " & $pCLRRuntimeHost & @CRLF)
    Local $oCLRRuntimeHost = ObjCreateInterface($pCLRRuntimeHost, $sIID_ICLRRuntimeHost, $sTag_CLRRuntimeHost)
    ConsoleWrite("> oCLRRuntimeHost" & IsObj($oCLRRuntimeHost)  & @CRLF & @CRLF)

    Local $iRet = 0
    $oCLRRuntimeHost.Start()
    ;$oCLRRuntimeHost.ExecuteInDefaultAppDomain(@ScriptDir & "\C#Library.dll", "ClassLibraryDemo.ClassDemo", "NetMsgBox", "AutoIt Rocks!!! " & @CRLF & "Danyfirex does too lol!!!", $iRet)
    ;ConsoleWrite(">Ret: " & $iRet & @CRLF)

    Local Const $sCLSID_CorRuntimeHost = "{CB2F6723-AB3A-11D2-9C40-00C04FA30A3E}"
    Local Const $sIID_ICorRuntimeHost = "{CB2F6722-AB3A-11D2-9C40-00C04FA30A3E}"
    Local $tCLSID_CorRuntimeHost = _WinAPI_CLSIDFromString($sCLSID_CorRuntimeHost)
    Local $tIID_ICorRuntimeHost = _WinAPI_CLSIDFromString($sIID_ICorRuntimeHost)
    Local Const $sTag_ICorRuntimeHost = _
      "CreateLogicalThreadState hresult();" & _
      "DeleteLogicalThreadState hresult();" & _
      "SwitchInLogicalThreadState hresult();" & _
      "SwitchOutLogicalThreadState hresult();" & _
      "LocksHeldByLogicalThread hresult();" & _
      "MapFile hresult();" & _
      "GetConfiguration hresult();" & _
      "Start hresult();" & _
      "Stop hresult();" & _
      "CreateDomain hresult();" & _
      "GetDefaultDomain hresult(ptr*);" & _
      "EnumDomains hresult();" & _
      "NextDomain hresult();" & _
      "CloseEnum hresult();" & _
      "CreateDomainEx hresult();" & _
      "CreateDomainSetup hresult();" & _
      "CreateEvidence hresult();" & _
      "UnloadDomain hresult();" & _
      "CurrentDomain hresult();"

    Local $tCorRuntimeHost = DllStructCreate("ptr")
    $oCLRRuntimeInfo.GetInterface(DllStructGetPtr($tCLSID_CorRuntimeHost), DllStructGetPtr($tIID_ICorRuntimeHost), DllStructGetPtr($tCorRuntimeHost))
    Local $pCorRuntimeHost = DllStructGetData($tCorRuntimeHost, 1)
    ConsoleWrite( "$pCorRuntimeHost = " & $pCorRuntimeHost & @CRLF )

    Local $oCorRuntimeHost = ObjCreateInterface($pCorRuntimeHost, $sIID_ICorRuntimeHost, $sTag_ICorRuntimeHost)
    ConsoleWrite( "IsObj( $oCorRuntimeHost ) = " & IsObj( $oCorRuntimeHost ) & @CRLF )

    $oCorRuntimeHost.Start()

    Local Const $sIID_AppDomain = "{05F696DC-2B29-3663-AD8B-C4389CF2A713}"
    Local Const $sTag_AppDomain = _
      "GetTypeInfoCount hresult();" & _
      "GetTypeInfo hresult();" & _
      "GetIDsOfNames hresult();" & _
      "Invoke hresult();" & _
      "get_ToString hresult();" & _
      "Equals hresult();" & _
      "GetHashCode hresult();" & _
      "GetType hresult();" & _
      "InitializeLifetimeService hresult();" & _
      "GetLifetimeService hresult();" & _
      "get_Evidence hresult();" & _
      "add_DomainUnload hresult();" & _
      "remove_DomainUnload hresult();" & _
      "add_AssemblyLoad hresult();" & _
      "remove_AssemblyLoad hresult();" & _
      "add_ProcessExit hresult();" & _
      "remove_ProcessExit hresult();" & _
      "add_TypeResolve hresult();" & _
      "remove_TypeResolve hresult();" & _
      "add_ResourceResolve hresult();" & _
      "remove_ResourceResolve hresult();" & _
      "add_AssemblyResolve hresult();" & _
      "remove_AssemblyResolve hresult();" & _
      "add_UnhandledException hresult();" & _
      "remove_UnhandledException hresult();" & _
      "DefineDynamicAssembly hresult();" & _
      "DefineDynamicAssembly_2 hresult();" & _
      "DefineDynamicAssembly_3 hresult();" & _
      "DefineDynamicAssembly_4 hresult();" & _
      "DefineDynamicAssembly_5 hresult();" & _
      "DefineDynamicAssembly_6 hresult();" & _
      "DefineDynamicAssembly_7 hresult();" & _
      "DefineDynamicAssembly_8 hresult();" & _
      "DefineDynamicAssembly_9 hresult();" & _
      "CreateInstance hresult();" & _
      "CreateInstanceFrom hresult();" & _
      "CreateInstance_2 hresult();" & _
      "CreateInstanceFrom_2 hresult();" & _
      "CreateInstance_3 hresult();" & _
      "CreateInstanceFrom_3 hresult();" & _
      "Load hresult();" & _
      "Load_2 hresult();" & _
      "Load_3 hresult();" & _
      "Load_4 hresult();" & _
      "Load_5 hresult();" & _
      "Load_6 hresult();" & _
      "Load_7 hresult();" & _
      "ExecuteAssembly hresult();" & _
      "ExecuteAssembly_2 hresult();" & _
      "ExecuteAssembly_3 hresult();" & _
      "get_FriendlyName hresult();" & _
      "get_BaseDirectory hresult();" & _
      "get_RelativeSearchPath hresult();" & _
      "get_ShadowCopyFiles hresult();" & _
      "GetAssemblies hresult();" & _
      "AppendPrivatePath hresult();" & _
      "ClearPrivatePath ) = 0; hresult();" & _
      "SetShadowCopyPath hresult();" & _
      "ClearShadowCopyPath ) = 0; hresult();" & _
      "SetCachePath hresult();" & _
      "SetData hresult();" & _
      "GetData hresult();" & _
      "SetAppDomainPolicy hresult();" & _
      "SetThreadPrincipal hresult();" & _
      "SetPrincipalPolicy hresult();" & _
      "DoCallBack hresult();" & _
      "get_DynamicDirectory hresult();"

    Local $pAppDomain
    $oCorRuntimeHost.GetDefaultDomain( $pAppDomain )
    ConsoleWrite( "$pAppDomain = " & Ptr( $pAppDomain ) & @CRLF )

    Local $oAppDomain = ObjCreateInterface( $pAppDomain, $sIID_AppDomain, $sTag_AppDomain )
    ConsoleWrite( "IsObj( $oAppDomain ) = " & IsObj( $oAppDomain ) & @CRLF & @CRLF)
  EndIf

EndIf

DllClose($hMSCorEE) ;free


Func _WinAPI_CLSIDFromString($sGUID)
  $tGUID = DllStructCreate('ulong Data1;ushort Data2;ushort Data3;byte Data4[8]')
  $iRet = DllCall('ole32.dll', 'uint', 'CLSIDFromString', 'wstr', $sGUID, 'ptr', DllStructGetPtr($tGUID))
  If (@error) Or ($iRet[0]) Then
    Return SetError(@error, @extended, 0)
  EndIf
  Return $tGUID
EndFunc   ;==>_WinAPI_CLSIDFromString