#include <Date.au3>
#include <Array.au3>

; ----------------------------------------
; .Net Conventional COM Object Examples
; ----------------------------------------
$oMyError = ObjEvent("AutoIt.Error","MyErrFunc")

; System.Collections.ArrayList Class
; ----------------------------------
ConsoleWrite("System.Collections.ArrayList Class" & @CRLF)
$DataList = ObjCreate ("System.Collections.ArrayList")
$DataList.Add( "B" )
$DataList.Add( "C" )
$DataList.Add( "E" )
$DataList.Add( "D" )
$DataList.Add( "A" )

$DataList.Sort()
;~ $Datalist.Reverse()  ; Reverse order
;~ $DataList.Remove("D") ; Removes an element

For $strItem in $DataList
    ConsoleWrite($strItem  & @CRLF)
Next
ConsoleWrite( @CRLF)

; System.Random Class
; Random number between 1 and 100 (1 included, 100 aparently not included)
; ------------------------------------------------------------------------
ConsoleWrite("System.Random Class" & @CRLF)
$objRandom = ObjCreate("System.Random")

ConsoleWrite($objRandom.Next_2(1,100)  & @CRLF)
ConsoleWrite( @CRLF)

; System.IO.StringWriter Class
; Concatenate strings. Faster than using "&"
; ------------------------------------------
ConsoleWrite("System.IO.StringWriter Class" & @CRLF)
$wrt = ObjCreate("System.IO.StringWriter")
For $i = 1 to 100
$s = String($i)
$wrt.Write_12( $s ) ; String. Write_11 for decimal, _10 for double, _9 for float
next
$s = $wrt.GetStringBuilder().ToString()

ConsoleWrite($s & @CRLF)
ConsoleWrite( @CRLF)

; System.Text.StringBuilder Class
; String Append Example
; -------------------------------
ConsoleWrite("System.Text.StringBuilder Class : Append / Replace / Insert" & @CRLF)
$sb = ObjCreate("System.Text.StringBuilder")
$sb.Append_3 ("I love deadlines. I like the whooshing sound they make as they fly by.")
$sb.Append_3 ("and the rest.")

ConsoleWrite ($sb.toString & @CRLF)
ConsoleWrite ($sb.Length & @CRLF)
ConsoleWrite ($sb.Capacity & @CRLF)
ConsoleWrite (chr($sb.chars(0))& @CRLF) ; Returns first char
ConsoleWrite ($sb.Replace("t", "d").Replace("l", "k").toString & @CRLF)

$sb.Insert_2 (7, "insert this ") ; After char 7, starting from 1

ConsoleWrite ($sb.toString & @CRLF)

$sb.remove(10,4).toString() ; Removes 4 chars starting from position 10

ConsoleWrite ($sb.toString & @CRLF)
ConsoleWrite( @CRLF)

; System.Text.StringBuilder Class
; Prints: ;1 is a loneliest number & ;2 is a happiest number
; ----------------------------------------------------------
Local $oVBS = ObjCreate("ScriptControl")
$oVBS.language = "VBScript"
Global Const $Nothing = $oVBS.eval("Nothing")
$oVBS = $Nothing

ConsoleWrite("System.Text.StringBuilder Class : AppendFormat with Variables" & @CRLF)
Local $aArray1[2] = ["John",_Now()]
Local $aArray2[2] = [1,"loneliest"]
Local $aArray3[2] = [2,"happiest"]


$sb = ObjCreate("System.Text.StringBuilder")
$sb.AppendFormat_5( $Nothing, "My name is {0} and the current date time is ;{1:dd MMMM yyyy HH:mm:ss};" & @CRLF, $aArray1)
$sb.AppendFormat_5 ( $Nothing, "{0} is a {1} number" & @CRLF,  $aArray2)
$sb.AppendFormat_5( $Nothing, "{0} is a {1} number" & @CRLF,  $aArray3)

ConsoleWrite($sb.ToString() & @CRLF)
ConsoleWrite( @CRLF)


; System.Text.StringBuilder Class
; A sorted dictionary object
; http://www.reliance-scada.com/en/support/articles/technical/vbscript-tip-working-with-an-object-list
;------------------------------------------------------------------------------------------------------
Local $Message, $ObjCreate, $i, $s

; Initializes the $Message.
$Message = ""

; Creates a list.
$ObjCreate = ObjCreate("System.Collections.SortedList")

; Fills the list.
$ObjCreate.Add( "Point", 1)
$ObjCreate.Add( "Point Cloud", 2)
$ObjCreate.Add( "Curve", 4)
$ObjCreate.Add( "Surface", 8)
$ObjCreate.Add( "Polysurface", 16)
$ObjCreate.Add( "Mesh", 32)

; Returns the element count.
$Message = $Message & "1: " & $ObjCreate.Count & @CRLF

; Returns the value by key.
$Message = $Message & "2: " & $ObjCreate("Surface") & @CRLF

; Returns the value at the index.
$s = ""
For $i = 0 To $ObjCreate.Count - 1
  $s = $s & String($ObjCreate.GetByIndex($i)) & " "
Next
$Message = $Message & "3: " & $s & @CRLF

; Verifies the existence of the key.
$Message = $Message & "4: " & $ObjCreate.ContainsKey("Polysurface") & @CRLF

; Verifies the existence of the value.
$Message = $Message & "5: " & $ObjCreate.ContainsValue(16) & @CRLF

; Returns the index of the key (searches for the element by key).
$Message = $Message & "6: " & $ObjCreate.IndexOfKey("Polysurface") & @CRLF

; Returns the index of the value (searches for the element by value).
$Message = $Message & "7: " & $ObjCreate.IndexOfValue(16) & @CRLF

; Removes the element by key.
$ObjCreate.Remove ("Polysurface" & @CRLF)

; Removes the element at the specified index.
$ObjCreate.RemoveAt (0)

; Removes all elements.
$ObjCreate.Clear

; Releases the list.
$ObjCreate = ""

; Displays the result.
MsgBox(0,"", $Message)

; System.Collections.Stack Class
; LIFO Last In First Out Stack
;-------------------------------
Local $Message, $Stack, $Item, $s

; Initializes the message.
$Message = ""

; Creates a list.
$Stack = ObjCreate("System.Collections.Stack")

; Fills the list.
$Stack.Push( "Item_1")
$Stack.Push( "Item_2")
$Stack.Push( "Item_3")
$Stack.Push( "Item_4")

; Goes through the list elements.
$s = ""
For  $Item In $Stack
  $s = $s & $Item & " "
Next
$Message = $Message & "1: " & $s & @CRLF

; Converts the list into an array.
$Message = $Message & "2: " & ($Stack.ToArray & ",") & @CRLF ; vbs JOIN Statement

; Returns the element count.
$Message = $Message & "3: " & $Stack.Count & @CRLF

; Verifies the existence of the value.
$Message = $Message & "4: " & $Stack.Contains("Item_2") & @CRLF

; Removes and returns the last element.
$Message = $Message & "5: " & $Stack.Pop & @CRLF

; Returns the last element (without removing it).
$Message = $Message & "6: " & $Stack.Peek & @CRLF

; Empties the list.
$Stack.Clear

; Releases the list.
$Stack = ""

; Displays the result.
MsgBox(0,"", $Message)

; System.Collections.Stack Class
; FIFO first in first out $Queue
;-------------------------------
Local $Message, $Queue, $Item, $s

; Initializes the message.
$Message = ""

; Creates a list.
$Queue = ObjCreate("System.Collections.Queue")

; Fills the list.
$Queue.Enqueue( "Item_1" )
$Queue.Enqueue( "Item_2" )
$Queue.Enqueue( "Item_3" )
$Queue.Enqueue ("Item_4" )


; Goes through the list elements.
$s = ""
For  $Item In $Queue
  $s = $s & $Item & " "
Next
$Message = $Message & "1: " & $s & @CRLF

; Converts the list into an array.
$Message = $Message & "2: " & ($Queue.ToArray & ",") & @CRLF ; vbs JOIN Statement

; Returns the element count.
$Message = $Message & "3: " & $Queue.Count & @CRLF

; Verifies the existence of the value.
$Message = $Message & "4: " & $Queue.Contains("Item_2") & @CRLF

; Removes and returns the first element.
$Message = $Message & "5: " & $Queue.Dequeue & @CRLF

; Returns the first element (without removing it).
$Message = $Message & "6: " & $Queue.Peek & @CRLF

; Empties the list.
$Queue.Clear

; Releases the list.
$Queue = ""

; Displays the result.
MsgBox(0,"", $Message)


Func MyErrFunc()
  $HexNumber=hex($oMyError.number,8)
  Msgbox(0,"COM Test","We intercepted a COM Error !"       & @CRLF  & @CRLF & _
			 "err.description is: "    & @TAB & $oMyError.description    & @CRLF & _
			 "err.windescription:"     & @TAB & $oMyError.windescription & @CRLF & _
			 "err.number is: "         & @TAB & $HexNumber              & @CRLF & _
			 "err.lastdllerror is: "   & @TAB & $oMyError.lastdllerror   & @CRLF & _
			 "err.scriptline is: "     & @TAB & $oMyError.scriptline     & @CRLF & _
			 "err.source is: "         & @TAB & $oMyError.source         & @CRLF & _
			 "err.helpfile is: "       & @TAB & $oMyError.helpfile       & @CRLF & _
			 "err.helpcontext is: "    & @TAB & $oMyError.helpcontext _
			)
  SetError(1)  ; to check for after this function returns
Endfunc