#AutoIt3Wrapper_UseX64=y

#include ".\Includes\CLR.Au3"

Global $aObjects[3]

Example() ; Form Using System.Windows.Forms.Form

Func Example()
#Region Register EventHelper
  ; Compile the helper class. This could be pre-compiled.
  Local $oHelper, $oHelperAsm = _CLR_CompileCSharp( FileRead( "EventHelperNEW.cs" ) ) ; NEWER Version
  $oHelperAsm.CreateInstance( "EventHelper", $oHelper )
  ConsoleWrite( "IsObj( $oHelper ) = " & IsObj( $oHelper ) & @CRLF )
#EndRegion

#Region Add Controls
  ConsoleWrite( "_CLR_LoadLibrary System.Drawing" & @CRLF )
  Local $oAssemblyDraw = _CLR_LoadLibrary( "System.Drawing" )
  ConsoleWrite( "IsObj( $oAssemblyDraw ) = " & IsObj( $oAssemblyDraw ) & @CRLF )

  ConsoleWrite( "_CLR_LoadLibrary System.Windows.Forms" & @CRLF )
  Local $oAssembly = _CLR_LoadLibrary( "System.Windows.Forms" )
  ConsoleWrite( "IsObj( $oAssembly ) = " & IsObj( $oAssembly ) & @CRLF )

  ConsoleWrite( @CRLF & "_CLR_CreateObject: System.Windows.Forms.Form" & @CRLF )
  Local $oForm = _CLR_CreateObject( $oAssembly, "System.Windows.Forms.Form" )
  ConsoleWrite( "IsObj( $oForm ) = " & IsObj( $oForm ) & @CRLF )

  $oForm.Text = "Form From Net - AutoIt Rocks"
  $oForm.Width = 800
  $oForm.Height = 400

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.Button 1" & @CRLF )
  Local $oButton1 = _CLR_CreateObject($oAssembly, "System.Windows.Forms.Button")
  $oButton1.Text = "button1"
  $oButton1.Width = 60
  $oButton1.Height = 30
  $oButton1.Left = 40
  $oButton1.Top = 10
  $aObjects[0] = $oButton1 ; Event trigger

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.Button 2" & @CRLF )
  Local $oButton2 = _CLR_CreateObject($oAssembly, "System.Windows.Forms.Button")
  $oButton2.Text = "button2"
  $oButton2.Width = 60
  $oButton2.Height = 30
  $oButton2.Left = $oButton1.Right + 50
  $oButton2.Top = $oButton1.Top
  $aObjects[1] = $oButton2 ; Event trigger

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.checkbox" & @CRLF )
  Local $checkbox1 = _CLR_CreateObject($oAssembly, "System.Windows.Forms.checkbox")
  $checkbox1.Top = 55
  $checkbox1.Left = 155
  $checkbox1.Checked = True
  $aObjects[2] = $checkbox1 ; Event trigger

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.ComboBox" & @CRLF )
  Local $Combo = _CLR_CreateObject($oAssembly, "System.Windows.Forms.ComboBox")
  $Combo.Width = 50
  $Combo.Top = 15
  $Combo.Left = 290

	For $i = 1 to 4
		$Combo.Items.Add("test" & $i)
	Next

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.Label" & @CRLF )
  Local $Label = _CLR_CreateObject($oAssembly, "System.Windows.Forms.Label")
  $Label.Width = 140
  $Label.Top = 55
  $Label.Left = 15
;~   $Label.Font = "Microsoft Sans Serif, 18pt, style=Bold, Italic" ; Does not Work
  $Label.Text = "Press The Buttons ..."

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.TextBox" & @CRLF )
  Local $Textbox = _CLR_CreateObject($oAssembly, "System.Windows.Forms.TextBox")
  $Textbox.Width = 120
  $Textbox.Top = 55
  $Textbox.Left = 295
  $Textbox.Text = "Enter Text Here ..."

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.TreeView" & @CRLF )
  Local $TreeView = _CLR_CreateObject($oAssembly, "System.Windows.Forms.TreeView")
  $TreeView.Top = 95
  $TreeView.left = 60

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.TreeNode" & @CRLF )
  Local $Node = _CLR_CreateObject($oAssembly, "System.Windows.Forms.TreeNode")
  $Node.Name = "empty"

 ; $TreeView.Nodes.add($node)

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.ListView" & @CRLF )
  Local $ListView = _CLR_CreateObject($oAssembly, "System.Windows.Forms.ListView")
  $ListView.Width = 220
  $ListView.Top = 95
  $ListView.Left = 295
  $ListView.Name = "listView1"

  Local $View = _CLR_CreateObject($oAssembly, "System.Windows.Forms.View")
  ConsoleWrite("$View : " & IsObj($View) & @CRLF & @CRLF)
  ;$ListView.View = $View.Details

  ConsoleWrite( @CRLF & "_CLR_CreateObject System.Windows.Forms.ColumnHeader" & @CRLF )
  Local $columnHeader1 = _CLR_CreateObject($oAssembly, "System.Windows.Forms.ColumnHeader")
  ConsoleWrite("$columnHeader1 : " & IsObj($columnHeader1) & @CRLF & @CRLF)

 ; $ListView.Columns.add($columnHeader1) ; Does not work !!!


 Local $oMsgButton = _CLR_CreateObject($oAssembly, "system.windows.forms.messageboxbuttons")
  ConsoleWrite("$oMsgButton : " & IsObj($oMsgButton) & @CRLF & @CRLF)

#EndRegion

#Region Events
  Local $hEventHandler = DllCallbackRegister( "EventHandler", "int", "ptr" )
  Local $pEventHandler = DllCallbackGetPtr( $hEventHandler )

  ; Add an event handler for the "OnEvent" event.  Use "" to pass the
  ; address as a string, since IDispatch doesn't support 64-bit integers.
  ; $oHelper.AddHandler( $oButton1, "Click", $pEventHandler )
  ; $oHelper.AddHandler( $oButton2, "Click", $pEventHandler )

  ; Make an event handler (event must be of the EventHandler type).
  Local $oHandler = $oHelper.MakeHandler( $pEventHandler )

  $oButton1.add_Click( $oHandler )
  $oButton2.add_Click( $oHandler )
  $checkbox1.add_Click( $oHandler )
#EndRegion

#Region Add Controls
  ;$oForm.Controls.Add( $oButton1 ) ; ERR
  $oButton1.Parent = $oForm ; OK
  $oButton2.Parent = $oForm
  $checkbox1.Parent = $oForm
  $Combo.Parent = $oForm
  $Label.Parent = $oForm
  $Textbox.Parent = $oForm
  $ListView.Parent = $oForm
  $TreeView.Parent = $oForm
 ; $Panel.Parent = $oForm
#EndRegion

  $oForm.ShowDialog()
  $oForm.Dispose()

EndFunc

#Region EventHandler
; Event handler is called with a LPArray of 1 parameter (variant pointer).
Func EventHandler($pprm)

    ConsoleWrite("$pprm = " & $pprm & @CRLF)

    Local $vVar = DllStructCreate($tagVARIANT, $pprm)
    $obj = ObjCreateInterface(DllStructGetData($vVar, "data"), $sIID_IDispatch)

    For $i = 0 To UBound($aObjects) - 1

		ConsoleWrite("EventsTrigger " & $obj & " " & $aObjects[$i] & @CRLF)

		If $obj = $aObjects[$i] Then
            MsgBox(0, "Event Output", $obj.ToString(), 0, $obj.Handle) ; give it parent handle not to have ten boxes one over other
            ExitLoop
        EndIf
    Next

EndFunc
#EndRegion

#cs
#Region EventHandler
; Our event handler is called with a SAFEARRAY of parameters.  This
; makes it much easier to get the type and value of each parameter.
Func EventHandler( $pprm )
  ConsoleWrite( "$pprm = " & $pprm & @CRLF )

  Local $iDim = SafeArrayGetDim( $pprm )
  ConsoleWrite( "$iDim = " & $iDim & @CRLF )

  Local $iLBound, $iUBound
  SafeArrayGetLBound( $pprm, 1, $iLBound )
  SafeArrayGetUBound( $pprm, 1, $iUBound )
  ConsoleWrite( "$iLBound = " & $iLBound & @CRLF )
  ConsoleWrite( "$iUBound = " & $iUBound & @CRLF )

  Local $tprm = DllStructCreate( $tagSAFEARRAY, $pprm )
  Local $fFeatures = DllStructGetData( $tprm, "fFeatures" )
  ConsoleWrite( "$fFeatures = 0x" & Hex( $fFeatures ) & @CRLF )
  Local $cbElements = DllStructGetData( $tprm, "cbElements" )
  ConsoleWrite( "$cbElements = " & $cbElements & @CRLF )

  Local $vt
  SafeArrayGetVartype( $pprm, $vt )
  ConsoleWrite( "$vt = " & $vt & @CRLF )

  Local $prmData, $pData, $obj
  SafeArrayAccessData( $pprm, $prmData )

  $vt = DllStructGetData( DllStructCreate( "word", $prmData ), 1 )
  ConsoleWrite( "$vt = " & $vt & @CRLF & @CRLF ) ; EventArgs Class
  $pData = DllStructGetData( DllStructCreate( "ptr", $prmData + 8 ), 1 )
  $obj = ObjCreateInterface( $pData, $sIID_IDispatch ) ; Convert Pointer to iDispatch

  SafeArrayUnaccessData( $pprm )

  For $i = 0 To UBound( $aObjects ) - 1
    If $obj.Equals( $aObjects[$i] ) Then ExitLoop
  Next

  If $i < UBound( $aObjects ) Then
    MsgBox( 0, "", $obj.ToString() )
  EndIf

EndFunc
#EndRegion
#ce