;~ #AutoIt3Wrapper_UseX64=y ; XPTable is x86 !!

#include ".\Includes\CLR.Au3"
#include <WinAPI.au3>

_Example()

Func _Example()

	Local $oXPTable = _CLR_LoadLibrary("XPTable.dll")
	ConsoleWrite("+Object: " & IsObj($oXPTable) & @CRLF)

	Local $oTable, $oColumnModel, $oTableModel
	$oTable = _CLR_CreateObject($oXPTable, "XPTable.Models.Table")
	$oColumnModel = _CLR_CreateObject($oXPTable, "XPTable.Models.ColumnModel")
	$oTableModel = _CLR_CreateObject($oXPTable, "XPTable.Models.TableModel")
	ConsoleWrite("IsObj( $oTable ) = " & IsObj($oTable) & @CRLF)
	ConsoleWrite("IsObj( $oColumnModel ) = " & IsObj($oColumnModel) & @CRLF)
	ConsoleWrite("IsObj( $oTableModel ) = " & IsObj($oTableModel) & @CRLF)

	$oTable.ColumnModel() = $oColumnModel
	$oTable.TableModel() = $oTableModel

	Local $oColumn0, $oColumn1, $oColumn2
	$oColumn0 = _CLR_CreateObject($oXPTable, "XPTable.Models.TextColumn", "MyTextColumn")
	$oColumn1 = _CLR_CreateObject($oXPTable, "XPTable.Models.CheckBoxColumn", "CheckBoxColumn")
	$oColumn2 = _CLR_CreateObject($oXPTable, "XPTable.Models.ButtonColumn", "MyButtonColumn")

	ConsoleWrite("IsObj( $oColumn0 ) = " & IsObj($oColumn0) & @CRLF)
	ConsoleWrite("IsObj( $oColumn1 ) = " & IsObj($oColumn1) & @CRLF)
	ConsoleWrite("IsObj( $oColumn2 ) = " & IsObj($oColumn2) & @CRLF)

	$oColumn0.Width = 110
	$oColumn1.Width = 110
	$oColumn2.Width = 110

	$oColumnModel.Columns.Add($oColumn0)
	$oColumnModel.Columns.Add($oColumn1)
	$oColumnModel.Columns.Add($oColumn2)


	ConsoleWrite("VisibleColumnCount = " & $oColumnModel.VisibleColumnCount() & @CRLF)

	Local $oRow = _CLR_CreateObject($oXPTable, "XPTable.Models.Row")
	ConsoleWrite("IsObj( $oRow ) = " & IsObj($oRow) & @CRLF)
	$oTableModel.Rows.Add($oRow)
	ConsoleWrite("Rows = " & $oTableModel.Rows.Count() & @CRLF)


	Local $oCell0, $oCell1, $oCell2
	$oCell0 = _CLR_CreateObject($oXPTable, "XPTable.Models.Cell", "MyCell1")
	$oCell1 = _CLR_CreateObject($oXPTable, "XPTable.Models.Cell", "MyCheckbox1")
	$oCell2 = _CLR_CreateObject($oXPTable, "XPTable.Models.Cell", "MyButton1")

	ConsoleWrite("IsObj( $oCell0 ) = " & IsObj($oCell0) & @CRLF)
	ConsoleWrite("IsObj( $oCell1 ) = " & IsObj($oCell1) & @CRLF)
	ConsoleWrite("IsObj( $oCell2 ) = " & IsObj($oCell2) & @CRLF)

	$oTableModel.Rows.Item(0).Cells.Add($oCell0)
	$oTableModel.Rows.Item(0).Cells.Add($oCell1)
	$oTableModel.Rows.Item(0).Cells.Add($oCell2)
	ConsoleWrite("Cells = " & $oTableModel.Rows.Item(0).Cells.Count() & @CRLF)

	$oTable.Left() = 10
	$oTable.Top() = 10
	$oTable.Width() = 340
	$oTable.Height() = 220


	Local $hTable = $oTable.Handle()
	Local $hGui = GUICreate("XPTable", 360, 240)

	_WinAPI_SetParent($hTable, $hGui)

	GUISetState()
	Do
	Until GUIGetMsg() = -3 ; $GUI_EVENT_CLOSE

EndFunc   ;==>_Example
